

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "global.h"

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)

GtkWidget*
create_window_Basis (void)
{
  GtkWidget *window_Basis;
  GtkWidget *vbox1;
  GtkWidget *label_Basis;
  GtkWidget *hbox1;
  GtkWidget *vbox2;
  GtkWidget *label_ADV_Adresse;
  GtkWidget *table1;
  GtkWidget *label_Basispfad;

  GtkWidget *label_Messdatum;
  GtkWidget *label_StatID;

  GtkWidget *table2;
  GtkWidget *hbox2;

  GtkWidget *label_dz_oMP2;
  GtkWidget *vbox3;

  GSList *radiobutton_Hellbach_group = NULL;
  GtkWidget *radiobutton_Nebel;
  GtkWidget *label_Gewaesser;
  GtkWidget *label_Vermessung;
  GtkWidget *label_Grenze;
  GtkWidget *label_dz_oMP;
  GtkWidget *table5;
  GtkWidget *label_dy_L;
  GtkWidget *label_dy_R;
  GtkWidget *label_Einh3;
  GtkWidget *label_Einh4;


  GtkWidget *table4;
  GtkWidget *label_dz_wsp;
  GtkWidget *label_dy_VP;
  GtkWidget *label_Einh1;
  GtkWidget *label_Einh2;

  GtkWidget *hbox3;
  GtkWidget *button_Eingabe_Basis;
  GtkWidget *alignment1;
  GtkWidget *hbox4;
  GtkWidget *image1;
  GtkWidget *label18;
  GtkWidget *button_Daten;
  GtkWidget *alignment31;
  GtkWidget *hbox46;
  GtkWidget *image31;
  GtkWidget *label82;
  GtkWidget *button_Analyse;
  GtkWidget *alignment4;
  GtkWidget *hbox7;
  GtkWidget *image4;
  GtkWidget *label21;
  GtkWidget *button_Ende;

  window_Basis = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (window_Basis), _("SonADDV"));

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (window_Basis), vbox1);

  label_Basis = gtk_label_new (_("Basisdaten"));
  gtk_widget_show (label_Basis);
  gtk_box_pack_start (GTK_BOX (vbox1), label_Basis, FALSE, FALSE, 5);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, TRUE, 0);

  vbox2 = gtk_vbox_new (FALSE, 5);
  gtk_widget_show (vbox2);
  gtk_box_pack_start (GTK_BOX (hbox1), vbox2, TRUE, FALSE, 5);

  label_ADV_Adresse = gtk_label_new (_("Verzeichnispfad der ADV-Daten:"));
  gtk_widget_show (label_ADV_Adresse);
  gtk_box_pack_start (GTK_BOX (vbox2), label_ADV_Adresse, FALSE, FALSE, 10);
  gtk_label_set_justify (GTK_LABEL (label_ADV_Adresse), GTK_JUSTIFY_CENTER);

  table1 = gtk_table_new (3, 2, FALSE);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (vbox2), table1, FALSE, FALSE, 5);
  gtk_container_set_border_width (GTK_CONTAINER (table1), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table1), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table1), 5);

  label_Basispfad = gtk_label_new (_("Basispfad:"));
  gtk_widget_show (label_Basispfad);
  gtk_table_attach (GTK_TABLE (table1), label_Basispfad, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label_Basispfad), 0, 0.5);

  entry_Basispfad = gtk_entry_new ();
  gtk_widget_show (entry_Basispfad);
  gtk_table_attach (GTK_TABLE (table1), entry_Basispfad, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_size_request (entry_Basispfad, 256, -1);
  gtk_entry_set_text (GTK_ENTRY (entry_Basispfad), _("/home/cno/Projekte/Messungen/"));

  label_Messdatum = gtk_label_new (_("Messdatum:"));
  gtk_widget_show (label_Messdatum);
  gtk_table_attach (GTK_TABLE (table1), label_Messdatum, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label_Messdatum), 0, 0.5);

  label_StatID = gtk_label_new (_("Stations ID:"));
  gtk_widget_show (label_StatID);
  gtk_table_attach (GTK_TABLE (table1), label_StatID, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label_StatID), 0, 0.5);

  entry_Messdatum = gtk_entry_new ();
  gtk_widget_show (entry_Messdatum);
  gtk_table_attach (GTK_TABLE (table1), entry_Messdatum, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_size_request (entry_Messdatum, 60, -1);
  gtk_entry_set_text (GTK_ENTRY (entry_Messdatum), _("000000"));

  entry_StatID = gtk_entry_new ();
  gtk_widget_show (entry_StatID);
  gtk_table_attach (GTK_TABLE (table1), entry_StatID, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_size_request (entry_StatID, 20, -1);
  gtk_entry_set_text (GTK_ENTRY (entry_StatID), _("I4"));

  table2 = gtk_table_new (4, 2, FALSE);
  gtk_widget_show (table2);
  gtk_box_pack_start (GTK_BOX (hbox1), table2, TRUE, FALSE, 5);
  gtk_container_set_border_width (GTK_CONTAINER (table2), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table2), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table2), 9);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox2);
  gtk_table_attach (GTK_TABLE (table2), hbox2, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);

  entry_dz_oMP = gtk_entry_new ();
  gtk_widget_show (entry_dz_oMP);
  gtk_box_pack_start (GTK_BOX (hbox2), entry_dz_oMP, FALSE, FALSE, 5);
  gtk_widget_set_size_request (entry_dz_oMP, 30, -1);
  gtk_entry_set_text (GTK_ENTRY (entry_dz_oMP), _("11"));

  label_dz_oMP2 = gtk_label_new (_("cm unter WSP"));
  gtk_widget_show (label_dz_oMP2);
  gtk_box_pack_start (GTK_BOX (hbox2), label_dz_oMP2, FALSE, FALSE, 0);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox3);
  gtk_table_attach (GTK_TABLE (table2), vbox3, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  radiobutton_Hellbach = gtk_radio_button_new_with_mnemonic (NULL, _("Hellbach"));
  gtk_widget_show (radiobutton_Hellbach);
  gtk_box_pack_start (GTK_BOX (vbox3), radiobutton_Hellbach, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_Hellbach), radiobutton_Hellbach_group);
  radiobutton_Hellbach_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_Hellbach));

  radiobutton_Nebel = gtk_radio_button_new_with_mnemonic (NULL, _("Nebel"));
  gtk_widget_show (radiobutton_Nebel);
  gtk_box_pack_start (GTK_BOX (vbox3), radiobutton_Nebel, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_Nebel), radiobutton_Hellbach_group);
  radiobutton_Hellbach_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_Nebel));

  label_Gewaesser = gtk_label_new (_("Gew\303\244sser:"));
  gtk_widget_show (label_Gewaesser);
  gtk_table_attach (GTK_TABLE (table2), label_Gewaesser, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (GTK_FILL), 4, 0);
  gtk_label_set_justify (GTK_LABEL (label_Gewaesser), GTK_JUSTIFY_CENTER);
  gtk_misc_set_alignment (GTK_MISC (label_Gewaesser), 0, 0.5);

  label_Vermessung = gtk_label_new (_("Vermessung:"));
  gtk_widget_show (label_Vermessung);
  gtk_table_attach (GTK_TABLE (table2), label_Vermessung, 0, 1, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label_Vermessung), 0, 0.5);

  label_Grenze = gtk_label_new (_("Distanz \"abflusswirksam\":"));
  gtk_widget_show (label_Grenze);
  gtk_table_attach (GTK_TABLE (table2), label_Grenze, 0, 1, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label_Grenze), 0, 0.5);

  label_dz_oMP = gtk_label_new (_("Distanz oberster Messpunkt"));
  gtk_widget_show (label_dz_oMP);
  gtk_table_attach (GTK_TABLE (table2), label_dz_oMP, 0, 1, 3, 4,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label_dz_oMP), 0, 0.5);

  table5 = gtk_table_new (2, 3, FALSE);
  gtk_widget_show (table5);
  gtk_table_attach (GTK_TABLE (table2), table5, 1, 2, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (GTK_EXPAND), 0, 0);
  gtk_table_set_col_spacings (GTK_TABLE (table5), 6);

  label_dy_L = gtk_label_new (_("dy_L"));
  gtk_widget_show (label_dy_L);
  gtk_table_attach (GTK_TABLE (table5), label_dy_L, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label_dy_L), 0, 0.5);

  label_dy_R = gtk_label_new (_("dy_R"));
  gtk_widget_show (label_dy_R);
  gtk_table_attach (GTK_TABLE (table5), label_dy_R, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label_dy_R), 0, 0.5);

  label_Einh3 = gtk_label_new (_("m"));
  gtk_widget_show (label_Einh3);
  gtk_table_attach (GTK_TABLE (table5), label_Einh3, 2, 3, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label_Einh3), 0, 0.5);

  label_Einh4 = gtk_label_new (_("m"));
  gtk_widget_show (label_Einh4);
  gtk_table_attach (GTK_TABLE (table5), label_Einh4, 2, 3, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label_Einh4), 0, 0.5);

  entry_dy_L = gtk_entry_new ();
  gtk_widget_show (entry_dy_L);
  gtk_table_attach (GTK_TABLE (table5), entry_dy_L, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND),
                    (GtkAttachOptions) (0), 0, 1);
  gtk_widget_set_size_request (entry_dy_L, 30, -1);
  gtk_entry_set_text (GTK_ENTRY (entry_dy_L), _("0.0"));

  entry_dy_R = gtk_entry_new ();
  gtk_widget_show (entry_dy_R);
  gtk_table_attach (GTK_TABLE (table5), entry_dy_R, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_size_request (entry_dy_R, 30, -1);
  gtk_entry_set_text (GTK_ENTRY (entry_dy_R), _("0.0"));

  table4 = gtk_table_new (2, 3, FALSE);
  gtk_widget_show (table4);
  gtk_table_attach (GTK_TABLE (table2), table4, 1, 2, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_table_set_col_spacings (GTK_TABLE (table4), 4);

  label_dz_wsp = gtk_label_new (_("dz_Wsp"));
  gtk_widget_show (label_dz_wsp);
  gtk_table_attach (GTK_TABLE (table4), label_dz_wsp, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label_dz_wsp), 0, 0.5);

  label_dy_VP = gtk_label_new (_("dy_VP"));
  gtk_widget_show (label_dy_VP);
  gtk_table_attach (GTK_TABLE (table4), label_dy_VP, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label_dy_VP), 0, 0.5);

  label_Einh1 = gtk_label_new (_("m"));
  gtk_widget_show (label_Einh1);
  gtk_table_attach (GTK_TABLE (table4), label_Einh1, 2, 3, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label_Einh1), 0, 0.5);

  label_Einh2 = gtk_label_new (_("m"));
  gtk_widget_show (label_Einh2);
  gtk_table_attach (GTK_TABLE (table4), label_Einh2, 2, 3, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label_Einh2), 0, 0.5);

  entry_dz_Wsp = gtk_entry_new ();
  gtk_widget_show (entry_dz_Wsp);
  gtk_table_attach (GTK_TABLE (table4), entry_dz_Wsp, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_size_request (entry_dz_Wsp, 50, -1);
  gtk_entry_set_text (GTK_ENTRY (entry_dz_Wsp), _("1.000"));

  entry_dy_VP = gtk_entry_new ();
  gtk_widget_show (entry_dy_VP);
  gtk_table_attach (GTK_TABLE (table4), entry_dy_VP, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_size_request (entry_dy_VP, 50, -1);
  gtk_entry_set_text (GTK_ENTRY (entry_dy_VP), _("1.000"));

  hbox3 = gtk_hbox_new (TRUE, 0);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox3, FALSE, FALSE, 5);

  button_Eingabe_Basis = gtk_button_new ();
  gtk_widget_show (button_Eingabe_Basis);
  gtk_box_pack_start (GTK_BOX (hbox3), button_Eingabe_Basis, FALSE, FALSE, 0);

  alignment1 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment1);
  gtk_container_add (GTK_CONTAINER (button_Eingabe_Basis), alignment1);

  hbox4 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox4);
  gtk_container_add (GTK_CONTAINER (alignment1), hbox4);

  image1 = gtk_image_new_from_stock ("gtk-apply", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image1);
  gtk_box_pack_start (GTK_BOX (hbox4), image1, FALSE, FALSE, 0);

  label18 = gtk_label_new_with_mnemonic (_("Eingabe"));
  gtk_widget_show (label18);
  gtk_box_pack_start (GTK_BOX (hbox4), label18, FALSE, FALSE, 0);

  button_Daten = gtk_button_new ();
  gtk_widget_show (button_Daten);
  gtk_box_pack_start (GTK_BOX (hbox3), button_Daten, FALSE, FALSE, 0);

  alignment31 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment31);
  gtk_container_add (GTK_CONTAINER (button_Daten), alignment31);

  hbox46 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox46);
  gtk_container_add (GTK_CONTAINER (alignment31), hbox46);

  image31 = gtk_image_new_from_stock ("gtk-media-play", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image31);
  gtk_box_pack_start (GTK_BOX (hbox46), image31, FALSE, FALSE, 0);

  label82 = gtk_label_new_with_mnemonic (_("Daten"));
  gtk_widget_show (label82);
  gtk_box_pack_start (GTK_BOX (hbox46), label82, FALSE, FALSE, 0);

  button_Analyse = gtk_button_new ();
  gtk_widget_show (button_Analyse);
  gtk_box_pack_start (GTK_BOX (hbox3), button_Analyse, FALSE, FALSE, 0);

  alignment4 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment4);
  gtk_container_add (GTK_CONTAINER (button_Analyse), alignment4);

  hbox7 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox7);
  gtk_container_add (GTK_CONTAINER (alignment4), hbox7);

  image4 = gtk_image_new_from_stock ("gtk-media-play", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image4);
  gtk_box_pack_start (GTK_BOX (hbox7), image4, FALSE, FALSE, 0);

  label21 = gtk_label_new_with_mnemonic (_("Analyse"));
  gtk_widget_show (label21);
  gtk_box_pack_start (GTK_BOX (hbox7), label21, FALSE, FALSE, 0);

  button_Ende = gtk_button_new_from_stock ("gtk-quit");
  gtk_widget_show (button_Ende);
  gtk_box_pack_start (GTK_BOX (hbox3), button_Ende, FALSE, FALSE, 0);

  g_signal_connect ((gpointer) button_Eingabe_Basis, "clicked",
                    G_CALLBACK (on_button_Eingabe_Basis_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_Daten, "clicked",
                    G_CALLBACK (on_button_Daten_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_Analyse, "clicked",
                    G_CALLBACK (on_button_Analyse_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_Ende, "clicked",
                    G_CALLBACK (gtk_main_quit),
                    NULL);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (window_Basis, window_Basis, "window_Basis");
  GLADE_HOOKUP_OBJECT (window_Basis, vbox1, "vbox1");
  GLADE_HOOKUP_OBJECT (window_Basis, label_Basis, "label_Basis");
  GLADE_HOOKUP_OBJECT (window_Basis, hbox1, "hbox1");
  GLADE_HOOKUP_OBJECT (window_Basis, vbox2, "vbox2");
  GLADE_HOOKUP_OBJECT (window_Basis, label_ADV_Adresse, "label_ADV_Adresse");
  GLADE_HOOKUP_OBJECT (window_Basis, table1, "table1");
  GLADE_HOOKUP_OBJECT (window_Basis, label_Basispfad, "label_Basispfad");
  GLADE_HOOKUP_OBJECT (window_Basis, entry_Basispfad, "entry_Basispfad");
  GLADE_HOOKUP_OBJECT (window_Basis, label_Messdatum, "label_Messdatum");
  GLADE_HOOKUP_OBJECT (window_Basis, label_StatID, "label_StatID");
  GLADE_HOOKUP_OBJECT (window_Basis, entry_Messdatum, "entry_Messdatum");
  GLADE_HOOKUP_OBJECT (window_Basis, entry_StatID, "entry_StatID");
  GLADE_HOOKUP_OBJECT (window_Basis, table2, "table2");
  GLADE_HOOKUP_OBJECT (window_Basis, hbox2, "hbox2");
  GLADE_HOOKUP_OBJECT (window_Basis, entry_dz_oMP, "entry_dz_oMP");
  GLADE_HOOKUP_OBJECT (window_Basis, label_dz_oMP2, "label_dz_oMP2");
  GLADE_HOOKUP_OBJECT (window_Basis, vbox3, "vbox3");
  GLADE_HOOKUP_OBJECT (window_Basis, radiobutton_Hellbach, "radiobutton_Hellbach");
  GLADE_HOOKUP_OBJECT (window_Basis, radiobutton_Nebel, "radiobutton_Nebel");
  GLADE_HOOKUP_OBJECT (window_Basis, label_Gewaesser, "label_Gewaesser");
  GLADE_HOOKUP_OBJECT (window_Basis, label_Vermessung, "label_Vermessung");
  GLADE_HOOKUP_OBJECT (window_Basis, label_Grenze, "label_Grenze");
  GLADE_HOOKUP_OBJECT (window_Basis, label_dz_oMP, "label_dz_oMP");
  GLADE_HOOKUP_OBJECT (window_Basis, table5, "table5");
  GLADE_HOOKUP_OBJECT (window_Basis, label_dy_L, "label_dy_L");
  GLADE_HOOKUP_OBJECT (window_Basis, label_dy_R, "label_dy_R");
  GLADE_HOOKUP_OBJECT (window_Basis, label_Einh3, "label_Einh3");
  GLADE_HOOKUP_OBJECT (window_Basis, label_Einh4, "label_Einh4");
  GLADE_HOOKUP_OBJECT (window_Basis, entry_dy_L, "entry_dy_L");
  GLADE_HOOKUP_OBJECT (window_Basis, entry_dy_R, "entry_dy_R");
  GLADE_HOOKUP_OBJECT (window_Basis, table4, "table4");
  GLADE_HOOKUP_OBJECT (window_Basis, label_dz_wsp, "label_dz_wsp");
  GLADE_HOOKUP_OBJECT (window_Basis, label_dy_VP, "label_dy_VP");
  GLADE_HOOKUP_OBJECT (window_Basis, label_Einh1, "label_Einh1");
  GLADE_HOOKUP_OBJECT (window_Basis, label_Einh2, "label_Einh2");
  GLADE_HOOKUP_OBJECT (window_Basis, entry_dz_Wsp, "entry_dz_Wsp");
  GLADE_HOOKUP_OBJECT (window_Basis, entry_dy_VP, "entry_dy_VP");
  GLADE_HOOKUP_OBJECT (window_Basis, hbox3, "hbox3");
  GLADE_HOOKUP_OBJECT (window_Basis, button_Eingabe_Basis, "button_Eingabe_Basis");
  GLADE_HOOKUP_OBJECT (window_Basis, alignment1, "alignment1");
  GLADE_HOOKUP_OBJECT (window_Basis, hbox4, "hbox4");
  GLADE_HOOKUP_OBJECT (window_Basis, image1, "image1");
  GLADE_HOOKUP_OBJECT (window_Basis, label18, "label18");
  GLADE_HOOKUP_OBJECT (window_Basis, button_Daten, "button_Daten");
  GLADE_HOOKUP_OBJECT (window_Basis, alignment31, "alignment31");
  GLADE_HOOKUP_OBJECT (window_Basis, hbox46, "hbox46");
  GLADE_HOOKUP_OBJECT (window_Basis, image31, "image31");
  GLADE_HOOKUP_OBJECT (window_Basis, label82, "label82");
  GLADE_HOOKUP_OBJECT (window_Basis, button_Analyse, "button_Analyse");
  GLADE_HOOKUP_OBJECT (window_Basis, alignment4, "alignment4");
  GLADE_HOOKUP_OBJECT (window_Basis, hbox7, "hbox7");
  GLADE_HOOKUP_OBJECT (window_Basis, image4, "image4");
  GLADE_HOOKUP_OBJECT (window_Basis, label21, "label21");
  GLADE_HOOKUP_OBJECT (window_Basis, button_Ende, "button_Ende");

  return window_Basis;
}

GtkWidget*
create_window_Daten (void)
{
  GtkWidget *window_Daten;
  GtkWidget *vbox4;
  GtkWidget *label_Daten;
  GtkWidget *hbox13;
  GtkWidget *vbox5;
  GtkWidget *label_Despiking;
  GtkWidget *table7;
  GtkWidget *label_PST_Lamelle;
  GtkWidget *label_PST_Punkt;
  GtkWidget *label_PST_Komp;

  GtkWidget *button_StartPST;
  GtkWidget *alignment28;
  GtkWidget *hbox43;
  GtkWidget *image28;
  GtkWidget *label78;
  GtkWidget *vbox17;
  GtkWidget *label_Datenzusammenfassung;
  GtkWidget *label_Hoehen;
  GtkWidget *button_Hoehen;
  GtkWidget *alignment29;
  GtkWidget *hbox44;
  GtkWidget *image29;
  GtkWidget *label79;
  GtkWidget *label_Hoehenkorrektur;
  GtkWidget *button_Hoehenkorrektur;
  GtkWidget *alignment30;
  GtkWidget *hbox45;
  GtkWidget *image30;
  GtkWidget *label80;
  GtkWidget *vbox16;
  GtkWidget *hbox40;
  GtkWidget *button_Basis;
  GtkWidget *alignment26;
  GtkWidget *hbox41;
  GtkWidget *image26;
  GtkWidget *label76;
  GtkWidget *button_Analyse;
  GtkWidget *alignment27;
  GtkWidget *hbox42;
  GtkWidget *image27;
  GtkWidget *label77;
  GtkWidget *button_Ende;

  window_Daten = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (window_Daten), _("SonADDV"));

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox4);
  gtk_container_add (GTK_CONTAINER (window_Daten), vbox4);

  label_Daten = gtk_label_new (_("Datenaufbereitung"));
  gtk_widget_show (label_Daten);
  gtk_box_pack_start (GTK_BOX (vbox4), label_Daten, FALSE, FALSE, 5);

  hbox13 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox13);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox13, FALSE, FALSE, 5);

  vbox5 = gtk_vbox_new (FALSE, 15);
  gtk_widget_show (vbox5);
  gtk_box_pack_start (GTK_BOX (hbox13), vbox5, TRUE, FALSE, 5);
  gtk_container_set_border_width (GTK_CONTAINER (vbox5), 5);

  label_Despiking = gtk_label_new (_("Despiking der Daten mit PST und Splineinterpolation"));
  gtk_widget_show (label_Despiking);
  gtk_box_pack_start (GTK_BOX (vbox5), label_Despiking, FALSE, FALSE, 0);

  table7 = gtk_table_new (3, 2, FALSE);
  gtk_widget_show (table7);
  gtk_box_pack_start (GTK_BOX (vbox5), table7, FALSE, FALSE, 5);
  gtk_table_set_row_spacings (GTK_TABLE (table7), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table7), 5);

  label_PST_Lamelle = gtk_label_new (_("Lamelle:"));
  gtk_widget_show (label_PST_Lamelle);
  gtk_table_attach (GTK_TABLE (table7), label_PST_Lamelle, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label_PST_Lamelle), 0, 0.5);

  label_PST_Punkt = gtk_label_new (_("Punktnr:."));
  gtk_widget_show (label_PST_Punkt);
  gtk_table_attach (GTK_TABLE (table7), label_PST_Punkt, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label_PST_Punkt), 0, 0.5);

  label_PST_Komp = gtk_label_new (_("Komponente:"));
  gtk_widget_show (label_PST_Komp);
  gtk_table_attach (GTK_TABLE (table7), label_PST_Komp, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label_PST_Komp), 0, 0.5);

  entry_PST_Komp = gtk_entry_new ();
  gtk_widget_show (entry_PST_Komp);
  gtk_table_attach (GTK_TABLE (table7), entry_PST_Komp, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_size_request (entry_PST_Komp, 15, -1);
  gtk_entry_set_text (GTK_ENTRY (entry_PST_Komp), _("u"));

  entry_PST_Punkt = gtk_entry_new ();
  gtk_widget_show (entry_PST_Punkt);
  gtk_table_attach (GTK_TABLE (table7), entry_PST_Punkt, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_size_request (entry_PST_Punkt, 30, -1);
  gtk_entry_set_text (GTK_ENTRY (entry_PST_Punkt), _("0"));

  entry_PST_Lamelle = gtk_entry_new ();
  gtk_widget_show (entry_PST_Lamelle);
  gtk_table_attach (GTK_TABLE (table7), entry_PST_Lamelle, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_size_request (entry_PST_Lamelle, 45, -1);
  gtk_entry_set_text (GTK_ENTRY (entry_PST_Lamelle), _("0_00"));

  button_StartPST = gtk_button_new ();
  gtk_widget_show (button_StartPST);
  gtk_box_pack_start (GTK_BOX (vbox5), button_StartPST, FALSE, FALSE, 0);

  alignment28 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment28);
  gtk_container_add (GTK_CONTAINER (button_StartPST), alignment28);

  hbox43 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox43);
  gtk_container_add (GTK_CONTAINER (alignment28), hbox43);

  image28 = gtk_image_new_from_stock ("gtk-apply", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image28);
  gtk_box_pack_start (GTK_BOX (hbox43), image28, FALSE, FALSE, 0);

  label78 = gtk_label_new_with_mnemonic (_("Start"));
  gtk_widget_show (label78);
  gtk_box_pack_start (GTK_BOX (hbox43), label78, FALSE, FALSE, 0);

  vbox17 = gtk_vbox_new (FALSE, 15);
  gtk_widget_show (vbox17);
  gtk_box_pack_start (GTK_BOX (hbox13), vbox17, TRUE, FALSE, 5);
  gtk_container_set_border_width (GTK_CONTAINER (vbox17), 5);

  label_Datenzusammenfassung = gtk_label_new (_("Datenzusammenfassung und -erg\303\244nzung"));
  gtk_widget_show (label_Datenzusammenfassung);
  gtk_box_pack_start (GTK_BOX (vbox17), label_Datenzusammenfassung, FALSE, FALSE, 0);

  label_Hoehen = gtk_label_new (_("Fehlende H\303\266hen:"));
  gtk_widget_show (label_Hoehen);
  gtk_box_pack_start (GTK_BOX (vbox17), label_Hoehen, FALSE, FALSE, 0);

  button_Hoehen = gtk_button_new ();
  gtk_widget_show (button_Hoehen);
  gtk_box_pack_start (GTK_BOX (vbox17), button_Hoehen, FALSE, FALSE, 0);

  alignment29 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment29);
  gtk_container_add (GTK_CONTAINER (button_Hoehen), alignment29);

  hbox44 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox44);
  gtk_container_add (GTK_CONTAINER (alignment29), hbox44);

  image29 = gtk_image_new_from_stock ("gtk-apply", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image29);
  gtk_box_pack_start (GTK_BOX (hbox44), image29, FALSE, FALSE, 0);

  label79 = gtk_label_new_with_mnemonic (_("Eingabe"));
  gtk_widget_show (label79);
  gtk_box_pack_start (GTK_BOX (hbox44), label79, FALSE, FALSE, 0);

  label_Hoehenkorrektur = gtk_label_new (_("H\303\266henkorrektur:"));
  gtk_widget_show (label_Hoehenkorrektur);
  gtk_box_pack_start (GTK_BOX (vbox17), label_Hoehenkorrektur, FALSE, FALSE, 0);

  button_Hoehenkorrektur = gtk_button_new ();
  gtk_widget_show (button_Hoehenkorrektur);
  gtk_box_pack_start (GTK_BOX (vbox17), button_Hoehenkorrektur, FALSE, FALSE, 0);

  alignment30 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment30);
  gtk_container_add (GTK_CONTAINER (button_Hoehenkorrektur), alignment30);

  hbox45 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox45);
  gtk_container_add (GTK_CONTAINER (alignment30), hbox45);

  image30 = gtk_image_new_from_stock ("gtk-apply", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image30);
  gtk_box_pack_start (GTK_BOX (hbox45), image30, FALSE, FALSE, 0);

  label80 = gtk_label_new_with_mnemonic (_("Eingabe"));
  gtk_widget_show (label80);
  gtk_box_pack_start (GTK_BOX (hbox45), label80, FALSE, FALSE, 0);

  vbox16 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox16);
  gtk_box_pack_start (GTK_BOX (vbox4), vbox16, FALSE, FALSE, 5);

  hbox40 = gtk_hbox_new (TRUE, 0);
  gtk_widget_show (hbox40);
  gtk_box_pack_start (GTK_BOX (vbox16), hbox40, TRUE, TRUE, 0);

  button_Basis = gtk_button_new ();
  gtk_widget_show (button_Basis);
  gtk_box_pack_start (GTK_BOX (hbox40), button_Basis, FALSE, FALSE, 0);

  alignment26 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment26);
  gtk_container_add (GTK_CONTAINER (button_Basis), alignment26);

  hbox41 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox41);
  gtk_container_add (GTK_CONTAINER (alignment26), hbox41);

  image26 = gtk_image_new_from_stock ("gtk-media-play", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image26);
  gtk_box_pack_start (GTK_BOX (hbox41), image26, FALSE, FALSE, 0);

  label76 = gtk_label_new_with_mnemonic (_("Basis"));
  gtk_widget_show (label76);
  gtk_box_pack_start (GTK_BOX (hbox41), label76, FALSE, FALSE, 0);

  button_Analyse = gtk_button_new ();
  gtk_widget_show (button_Analyse);
  gtk_box_pack_start (GTK_BOX (hbox40), button_Analyse, FALSE, FALSE, 0);

  alignment27 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment27);
  gtk_container_add (GTK_CONTAINER (button_Analyse), alignment27);

  hbox42 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox42);
  gtk_container_add (GTK_CONTAINER (alignment27), hbox42);

  image27 = gtk_image_new_from_stock ("gtk-media-play", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image27);
  gtk_box_pack_start (GTK_BOX (hbox42), image27, FALSE, FALSE, 0);

  label77 = gtk_label_new_with_mnemonic (_("Analyse"));
  gtk_widget_show (label77);
  gtk_box_pack_start (GTK_BOX (hbox42), label77, FALSE, FALSE, 0);

  button_Ende = gtk_button_new_from_stock ("gtk-quit");
  gtk_widget_show (button_Ende);
  gtk_box_pack_start (GTK_BOX (hbox40), button_Ende, FALSE, FALSE, 0);

  g_signal_connect ((gpointer) button_StartPST, "clicked",
                    G_CALLBACK (on_button_StartPST_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_Hoehen, "clicked",
                    G_CALLBACK (on_button_Hoehen_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_Hoehenkorrektur, "clicked",
                    G_CALLBACK (on_button_Hoehenkorrektur_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_Basis, "clicked",
                    G_CALLBACK (on_button_Basis_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_Analyse, "clicked",
                    G_CALLBACK (on_button_Analyse_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_Ende, "clicked",
                    G_CALLBACK (gtk_main_quit),
                    NULL);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (window_Daten, window_Daten, "window_Daten");
  GLADE_HOOKUP_OBJECT (window_Daten, vbox4, "vbox4");
  GLADE_HOOKUP_OBJECT (window_Daten, label_Daten, "label_Daten");
  GLADE_HOOKUP_OBJECT (window_Daten, hbox13, "hbox13");
  GLADE_HOOKUP_OBJECT (window_Daten, vbox5, "vbox5");
  GLADE_HOOKUP_OBJECT (window_Daten, label_Despiking, "label_Despiking");
  GLADE_HOOKUP_OBJECT (window_Daten, table7, "table7");
  GLADE_HOOKUP_OBJECT (window_Daten, label_PST_Lamelle, "label_PST_Lamelle");
  GLADE_HOOKUP_OBJECT (window_Daten, label_PST_Punkt, "label_PST_Punkt");
  GLADE_HOOKUP_OBJECT (window_Daten, label_PST_Komp, "label_PST_Komp");
  GLADE_HOOKUP_OBJECT (window_Daten, entry_PST_Komp, "entry_PST_Komp");
  GLADE_HOOKUP_OBJECT (window_Daten, entry_PST_Punkt, "entry_PST_Punkt");
  GLADE_HOOKUP_OBJECT (window_Daten, entry_PST_Lamelle, "entry_PST_Lamelle");
  GLADE_HOOKUP_OBJECT (window_Daten, button_StartPST, "button_StartPST");
  GLADE_HOOKUP_OBJECT (window_Daten, alignment28, "alignment28");
  GLADE_HOOKUP_OBJECT (window_Daten, hbox43, "hbox43");
  GLADE_HOOKUP_OBJECT (window_Daten, image28, "image28");
  GLADE_HOOKUP_OBJECT (window_Daten, label78, "label78");
  GLADE_HOOKUP_OBJECT (window_Daten, vbox17, "vbox17");
  GLADE_HOOKUP_OBJECT (window_Daten, label_Datenzusammenfassung, "label_Datenzusammenfassung");
  GLADE_HOOKUP_OBJECT (window_Daten, label_Hoehen, "label_Hoehen");
  GLADE_HOOKUP_OBJECT (window_Daten, button_Hoehen, "button_Hoehen");
  GLADE_HOOKUP_OBJECT (window_Daten, alignment29, "alignment29");
  GLADE_HOOKUP_OBJECT (window_Daten, hbox44, "hbox44");
  GLADE_HOOKUP_OBJECT (window_Daten, image29, "image29");
  GLADE_HOOKUP_OBJECT (window_Daten, label79, "label79");
  GLADE_HOOKUP_OBJECT (window_Daten, label_Hoehenkorrektur, "label_Hoehenkorrektur");
  GLADE_HOOKUP_OBJECT (window_Daten, button_Hoehenkorrektur, "button_Hoehenkorrektur");
  GLADE_HOOKUP_OBJECT (window_Daten, alignment30, "alignment30");
  GLADE_HOOKUP_OBJECT (window_Daten, hbox45, "hbox45");
  GLADE_HOOKUP_OBJECT (window_Daten, image30, "image30");
  GLADE_HOOKUP_OBJECT (window_Daten, label80, "label80");
  GLADE_HOOKUP_OBJECT (window_Daten, vbox16, "vbox16");
  GLADE_HOOKUP_OBJECT (window_Daten, hbox40, "hbox40");
  GLADE_HOOKUP_OBJECT (window_Daten, button_Basis, "button_Basis");
  GLADE_HOOKUP_OBJECT (window_Daten, alignment26, "alignment26");
  GLADE_HOOKUP_OBJECT (window_Daten, hbox41, "hbox41");
  GLADE_HOOKUP_OBJECT (window_Daten, image26, "image26");
  GLADE_HOOKUP_OBJECT (window_Daten, label76, "label76");
  GLADE_HOOKUP_OBJECT (window_Daten, button_Analyse, "button_Analyse");
  GLADE_HOOKUP_OBJECT (window_Daten, alignment27, "alignment27");
  GLADE_HOOKUP_OBJECT (window_Daten, hbox42, "hbox42");
  GLADE_HOOKUP_OBJECT (window_Daten, image27, "image27");
  GLADE_HOOKUP_OBJECT (window_Daten, label77, "label77");
  GLADE_HOOKUP_OBJECT (window_Daten, button_Ende, "button_Ende");

  return window_Daten;
}

GtkWidget*
create_window_Analyse (void)
{
  GtkWidget *window_Analyse;
  GtkWidget *vbox9;
  GtkWidget *vbox10;
  GtkWidget *label_Analyse;
  GtkWidget *table15;
	
  GtkWidget *label_Mittelwerte;
  GtkWidget *label_Fluktuation;
  GtkWidget *label_Zeitmassstab;
  GtkWidget *label_Laengenmassstab;
  GtkWidget *label_Schubspannung;
  GtkWidget *label_Pfad;
  GtkWidget *label_Schubspannungortho;

  GtkWidget *button_Mittelwerte;
  GtkWidget *alignment17;
  GtkWidget *hbox28;
  GtkWidget *image17;
  GtkWidget *label56;
  GtkWidget *button_Standardabweichung;
  GtkWidget *alignment18;
  GtkWidget *hbox29;
  GtkWidget *image18;
  GtkWidget *label57;
  GtkWidget *button_Zeitmassstab;
  GtkWidget *alignment19;
  GtkWidget *hbox30;
  GtkWidget *image19;
  GtkWidget *label58;
  GtkWidget *button_Laengenmassstab;
  GtkWidget *alignment20;
  GtkWidget *hbox31;
  GtkWidget *image20;
  GtkWidget *label59;
  GtkWidget *button_Schubspannung;
  GtkWidget *alignment21;
  GtkWidget *hbox32;
  GtkWidget *image21;
  GtkWidget *label60;
  GtkWidget *button_Schubspannungortho;
  GtkWidget *alignment122;
  GtkWidget *hbox133;
  GtkWidget *image122;
  GtkWidget *labe1l61;
  
  GtkWidget *vbox11;
  GtkWidget *label_Ausgabe;
  GtkWidget *hbox33;
  GtkWidget *vbox15;
  GtkWidget *radiobutton_Mittelwerte;
  GSList *radiobutton_Mittelwerte_group = NULL;

  GtkWidget *vbox13;
  GtkWidget *radiobutton_relativ;
  GSList *radiobutton_relativ_group = NULL;

  GtkWidget *button_Surfergeometrie;
  GtkWidget *alignment22;
  GtkWidget *hbox34;
  GtkWidget *image22;
  GtkWidget *label67;
  GtkWidget *hbox24;
  GtkWidget *button_Basis;
  GtkWidget *alignment14;
  GtkWidget *hbox25;
  GtkWidget *image14;
  GtkWidget *label41;
  GtkWidget *button_Daten;
  GtkWidget *alignment32;
  GtkWidget *hbox47;
  GtkWidget *image32;
  GtkWidget *label83;
  GtkWidget *button_Ende;
  
  

  window_Analyse = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (window_Analyse), _("SonADDV"));

  vbox9 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox9);
  gtk_container_add (GTK_CONTAINER (window_Analyse), vbox9);

  vbox10 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox10);
  gtk_box_pack_start (GTK_BOX (vbox9), vbox10, FALSE, FALSE, 5);

  label_Analyse = gtk_label_new (_("Analyse"));
  gtk_widget_show (label_Analyse);
  gtk_box_pack_start (GTK_BOX (vbox10), label_Analyse, FALSE, FALSE, 0);

  table15 = gtk_table_new (5, 6, FALSE);
  gtk_widget_show (table15);
  gtk_box_pack_start (GTK_BOX (vbox10), table15, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (table15), 10);
  gtk_table_set_row_spacings (GTK_TABLE (table15), 2);
  gtk_table_set_col_spacings (GTK_TABLE (table15), 5);

  label_Mittelwerte = gtk_label_new (_("Mittlere Punktgeschwindigkeiten"));
  gtk_widget_show (label_Mittelwerte);
  gtk_table_attach (GTK_TABLE (table15), label_Mittelwerte, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label_Mittelwerte), 0, 0.5);

  label_Fluktuation = gtk_label_new (_("Turbulenzintensit\303\244t (v_r.m.s.)"));
  gtk_widget_show (label_Fluktuation);
  gtk_table_attach (GTK_TABLE (table15), label_Fluktuation, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label_Fluktuation), 0, 0.5);

  label_Zeitmassstab = gtk_label_new (_("Integraler Zeitma\303\237stab"));
  gtk_widget_show (label_Zeitmassstab);
  gtk_table_attach (GTK_TABLE (table15), label_Zeitmassstab, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label_Zeitmassstab), 0, 0.5);

  label_Laengenmassstab = gtk_label_new (_("Makroturb. L\303\244ngenma\303\237stab"));
  gtk_widget_show (label_Laengenmassstab);
  gtk_table_attach (GTK_TABLE (table15), label_Laengenmassstab, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label_Laengenmassstab), 0, 0.5);

  label_Schubspannung = gtk_label_new (_("Schubspannungsverteilung (xyz)"));
  gtk_widget_show (label_Schubspannung);
  gtk_table_attach (GTK_TABLE (table15), label_Schubspannung, 0, 1, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label_Schubspannung), 0, 0.5);

  label_Schubspannungortho = gtk_label_new (_("Schubspannungsverteilung (xr)"));
  gtk_widget_show (label_Schubspannungortho);
  gtk_table_attach (GTK_TABLE (table15), label_Schubspannungortho, 0, 1, 5, 6,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label_Schubspannungortho), 0, 0.5);

  label_Pfad = gtk_label_new (_("Speicherpfad:"));
  gtk_widget_show (label_Pfad);
  gtk_table_attach (GTK_TABLE (table15), label_Pfad, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label_Pfad), 0, 0.5);

  label_Pfad = gtk_label_new (_("Speicherpfad:"));
  gtk_widget_show (label_Pfad);
  gtk_table_attach (GTK_TABLE (table15), label_Pfad, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label_Pfad), 0, 0.5);

  label_Pfad = gtk_label_new (_("Speicherpfad:"));
  gtk_widget_show (label_Pfad);
  gtk_table_attach (GTK_TABLE (table15), label_Pfad, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label_Pfad), 0, 0.5);

  label_Pfad = gtk_label_new (_("Speicherpfad:"));
  gtk_widget_show (label_Pfad);
  gtk_table_attach (GTK_TABLE (table15), label_Pfad, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label_Pfad), 0, 0.5);

  label_Pfad = gtk_label_new (_("Speicherpfad:"));
  gtk_widget_show (label_Pfad);
  gtk_table_attach (GTK_TABLE (table15), label_Pfad, 1, 2, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label_Pfad), 0, 0.5);

  label_Pfad = gtk_label_new (_("Speicherpfad:"));
  gtk_widget_show (label_Pfad);
  gtk_table_attach (GTK_TABLE (table15), label_Pfad, 1, 2, 5, 6,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label_Pfad), 0, 0.5);

  entry_Pfad_Mittelwerte = gtk_entry_new ();
  gtk_widget_show (entry_Pfad_Mittelwerte);
  gtk_table_attach (GTK_TABLE (table15), entry_Pfad_Mittelwerte, 2, 3, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
	
  entry_Pfad_Standardabweichung = gtk_entry_new ();
  gtk_widget_show (entry_Pfad_Standardabweichung);
  gtk_table_attach (GTK_TABLE (table15), entry_Pfad_Standardabweichung, 2, 3, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);


  entry_Pfad_Zeitmassstab = gtk_entry_new ();
  gtk_widget_show (entry_Pfad_Zeitmassstab);
  gtk_table_attach (GTK_TABLE (table15), entry_Pfad_Zeitmassstab, 2, 3, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);


  entry_Pfad_Laengenskale = gtk_entry_new ();
  gtk_widget_show (entry_Pfad_Laengenskale);
  gtk_table_attach (GTK_TABLE (table15), entry_Pfad_Laengenskale, 2, 3, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);


  entry_Pfad_Schubspannung = gtk_entry_new ();
  gtk_widget_show (entry_Pfad_Schubspannung);
  gtk_table_attach (GTK_TABLE (table15), entry_Pfad_Schubspannung, 2, 3, 4, 5,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  entry_Pfad_Schubspannungortho = gtk_entry_new ();
  gtk_widget_show (entry_Pfad_Schubspannungortho);
  gtk_table_attach (GTK_TABLE (table15), entry_Pfad_Schubspannungortho, 2, 3, 5, 6,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);


  checkbutton_Autokorrel = gtk_check_button_new_with_mnemonic (_("Autokorrelationskoeffizienten"));
  gtk_widget_show (checkbutton_Autokorrel);
  gtk_table_attach (GTK_TABLE (table15), checkbutton_Autokorrel, 3, 4, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  checkbutton_Tensor = gtk_check_button_new_with_mnemonic (_("Spannungstensor"));
  gtk_widget_show (checkbutton_Tensor);
  gtk_table_attach (GTK_TABLE (table15), checkbutton_Tensor, 3, 4, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  button_Mittelwerte = gtk_button_new ();
  gtk_widget_show (button_Mittelwerte);
  gtk_table_attach (GTK_TABLE (table15), button_Mittelwerte, 4, 5, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  alignment17 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment17);
  gtk_container_add (GTK_CONTAINER (button_Mittelwerte), alignment17);

  hbox28 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox28);
  gtk_container_add (GTK_CONTAINER (alignment17), hbox28);

  image17 = gtk_image_new_from_stock ("gtk-apply", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image17);
  gtk_box_pack_start (GTK_BOX (hbox28), image17, FALSE, FALSE, 0);

  label56 = gtk_label_new_with_mnemonic (_("Start"));
  gtk_widget_show (label56);
  gtk_box_pack_start (GTK_BOX (hbox28), label56, FALSE, FALSE, 0);

  button_Standardabweichung = gtk_button_new ();
  gtk_widget_show (button_Standardabweichung);
  gtk_table_attach (GTK_TABLE (table15), button_Standardabweichung, 4, 5, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  alignment18 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment18);
  gtk_container_add (GTK_CONTAINER (button_Standardabweichung), alignment18);

  hbox29 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox29);
  gtk_container_add (GTK_CONTAINER (alignment18), hbox29);

  image18 = gtk_image_new_from_stock ("gtk-apply", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image18);
  gtk_box_pack_start (GTK_BOX (hbox29), image18, FALSE, FALSE, 0);

  label57 = gtk_label_new_with_mnemonic (_("Start"));
  gtk_widget_show (label57);
  gtk_box_pack_start (GTK_BOX (hbox29), label57, FALSE, FALSE, 0);

  button_Zeitmassstab = gtk_button_new ();
  gtk_widget_show (button_Zeitmassstab);
  gtk_table_attach (GTK_TABLE (table15), button_Zeitmassstab, 4, 5, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  alignment19 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment19);
  gtk_container_add (GTK_CONTAINER (button_Zeitmassstab), alignment19);

  hbox30 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox30);
  gtk_container_add (GTK_CONTAINER (alignment19), hbox30);

  image19 = gtk_image_new_from_stock ("gtk-apply", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image19);
  gtk_box_pack_start (GTK_BOX (hbox30), image19, FALSE, FALSE, 0);

  label58 = gtk_label_new_with_mnemonic (_("Start"));
  gtk_widget_show (label58);
  gtk_box_pack_start (GTK_BOX (hbox30), label58, FALSE, FALSE, 0);

  button_Laengenmassstab = gtk_button_new ();
  gtk_widget_show (button_Laengenmassstab);
  gtk_table_attach (GTK_TABLE (table15), button_Laengenmassstab, 4, 5, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  alignment20 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment20);
  gtk_container_add (GTK_CONTAINER (button_Laengenmassstab), alignment20);

  hbox31 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox31);
  gtk_container_add (GTK_CONTAINER (alignment20), hbox31);

  image20 = gtk_image_new_from_stock ("gtk-apply", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image20);
  gtk_box_pack_start (GTK_BOX (hbox31), image20, FALSE, FALSE, 0);

  label59 = gtk_label_new_with_mnemonic (_("Start"));
  gtk_widget_show (label59);
  gtk_box_pack_start (GTK_BOX (hbox31), label59, FALSE, FALSE, 0);

  button_Schubspannung = gtk_button_new ();
  gtk_widget_show (button_Schubspannung);
  gtk_table_attach (GTK_TABLE (table15), button_Schubspannung, 4, 5, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  alignment21 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment21);
  gtk_container_add (GTK_CONTAINER (button_Schubspannung), alignment21);

  hbox32 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox32);
  gtk_container_add (GTK_CONTAINER (alignment21), hbox32);

  image21 = gtk_image_new_from_stock ("gtk-apply", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image21);
  gtk_box_pack_start (GTK_BOX (hbox32), image21, FALSE, FALSE, 0);

  label60 = gtk_label_new_with_mnemonic (_("Start"));
  gtk_widget_show (label60);
  gtk_box_pack_start (GTK_BOX (hbox32), label60, FALSE, FALSE, 0);

  button_Schubspannungortho = gtk_button_new ();
  gtk_widget_show (button_Schubspannungortho);
  gtk_table_attach (GTK_TABLE (table15), button_Schubspannungortho, 4, 5, 5, 6,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  alignment122 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment122);
  gtk_container_add (GTK_CONTAINER (button_Schubspannungortho), alignment122);

  hbox133 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox133);
  gtk_container_add (GTK_CONTAINER (alignment122), hbox133);

  image122 = gtk_image_new_from_stock ("gtk-apply", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image122);
  gtk_box_pack_start (GTK_BOX (hbox133), image122, FALSE, FALSE, 0);

  labe1l61 = gtk_label_new_with_mnemonic (_("Start"));
  gtk_widget_show (labe1l61);
  gtk_box_pack_start (GTK_BOX (hbox133), labe1l61, FALSE, FALSE, 0);

  vbox11 = gtk_vbox_new (FALSE, 10);
  gtk_widget_show (vbox11);
  gtk_box_pack_start (GTK_BOX (vbox9), vbox11, FALSE, FALSE, 5);
  gtk_container_set_border_width (GTK_CONTAINER (vbox11), 5);

  label_Ausgabe = gtk_label_new (_("Zus\303\244tzliches Ausgabeformat"));
  gtk_widget_show (label_Ausgabe);
  gtk_box_pack_start (GTK_BOX (vbox11), label_Ausgabe, FALSE, FALSE, 0);

  hbox33 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox33);
  gtk_box_pack_start (GTK_BOX (vbox11), hbox33, TRUE, TRUE, 0);

  vbox15 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox15);
  gtk_box_pack_start (GTK_BOX (hbox33), vbox15, TRUE, TRUE, 0);

  radiobutton_Mittelwerte = gtk_radio_button_new_with_mnemonic (NULL, _("Mittlere Punktgeschwindigkeiten"));
  gtk_widget_show (radiobutton_Mittelwerte);
  gtk_box_pack_start (GTK_BOX (vbox15), radiobutton_Mittelwerte, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_Mittelwerte), radiobutton_Mittelwerte_group);
  radiobutton_Mittelwerte_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_Mittelwerte));

  radiobutton_Standardabweichungen = gtk_radio_button_new_with_mnemonic (NULL, _("Turbulenzintensit\303\244t (v r.m.s.)"));
  gtk_widget_show (radiobutton_Standardabweichungen);
  gtk_box_pack_start (GTK_BOX (vbox15), radiobutton_Standardabweichungen, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_Standardabweichungen), radiobutton_Mittelwerte_group);
  radiobutton_Mittelwerte_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_Standardabweichungen));

  radiobutton_Zeitmassstab = gtk_radio_button_new_with_mnemonic (NULL, _("Integraler Zeitmassstab"));
  gtk_widget_show (radiobutton_Zeitmassstab);
  gtk_box_pack_start (GTK_BOX (vbox15), radiobutton_Zeitmassstab, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_Zeitmassstab), radiobutton_Mittelwerte_group);
  radiobutton_Mittelwerte_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_Zeitmassstab));

  radiobutton_Laengenmassstab = gtk_radio_button_new_with_mnemonic (NULL, _("Makroturb. L\303\244ngenma\303\237stab"));
  gtk_widget_show (radiobutton_Laengenmassstab);
  gtk_box_pack_start (GTK_BOX (vbox15), radiobutton_Laengenmassstab, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_Laengenmassstab), radiobutton_Mittelwerte_group);
  radiobutton_Mittelwerte_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_Laengenmassstab));

  radiobutton_Schubspannung = gtk_radio_button_new_with_mnemonic (NULL, _("Schubspannungsverteilung (xyz)"));
  gtk_widget_show (radiobutton_Schubspannung);
  gtk_box_pack_start (GTK_BOX (vbox15), radiobutton_Schubspannung, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_Schubspannung), radiobutton_Mittelwerte_group);
  radiobutton_Mittelwerte_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_Schubspannung));

  radiobutton_Schubspannungortho = gtk_radio_button_new_with_mnemonic (NULL, _("Schubspannungsverteilung (xr)"));
  gtk_widget_show (radiobutton_Schubspannungortho);
  gtk_box_pack_start (GTK_BOX (vbox15), radiobutton_Schubspannungortho, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_Schubspannungortho), radiobutton_Mittelwerte_group);
  radiobutton_Mittelwerte_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_Schubspannungortho));

  vbox13 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox13);
  gtk_box_pack_start (GTK_BOX (hbox33), vbox13, TRUE, TRUE, 0);

  radiobutton_relativ = gtk_radio_button_new_with_mnemonic (NULL, _("Relative H\303\266hen und Breiten"));
  gtk_widget_show (radiobutton_relativ);
  gtk_box_pack_start (GTK_BOX (vbox13), radiobutton_relativ, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_relativ), radiobutton_relativ_group);
  radiobutton_relativ_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_relativ));

  radiobutton_absolut = gtk_radio_button_new_with_mnemonic (NULL, _("Absolute H\303\266hen (m HN) und lokale Breiten"));
  gtk_widget_show (radiobutton_absolut);
  gtk_box_pack_start (GTK_BOX (vbox13), radiobutton_absolut, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_absolut), radiobutton_relativ_group);
  radiobutton_relativ_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_absolut));

  radiobutton_absrel = gtk_radio_button_new_with_mnemonic (NULL, _("Relative und absolute Darstellung"));
  gtk_widget_show (radiobutton_absrel);
  gtk_box_pack_start (GTK_BOX (vbox13), radiobutton_absrel, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_absrel), radiobutton_relativ_group);
  radiobutton_relativ_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_absrel));

  button_Surfergeometrie = gtk_button_new ();
  gtk_widget_show (button_Surfergeometrie);
  gtk_box_pack_start (GTK_BOX (hbox33), button_Surfergeometrie, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (button_Surfergeometrie), 5);

  alignment22 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment22);
  gtk_container_add (GTK_CONTAINER (button_Surfergeometrie), alignment22);

  hbox34 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox34);
  gtk_container_add (GTK_CONTAINER (alignment22), hbox34);

  image22 = gtk_image_new_from_stock ("gtk-apply", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image22);
  gtk_box_pack_start (GTK_BOX (hbox34), image22, FALSE, FALSE, 0);

  label67 = gtk_label_new_with_mnemonic (_("Start"));
  gtk_widget_show (label67);
  gtk_box_pack_start (GTK_BOX (hbox34), label67, FALSE, FALSE, 0);

  hbox24 = gtk_hbox_new (TRUE, 15);
  gtk_widget_show (hbox24);
  gtk_box_pack_start (GTK_BOX (vbox9), hbox24, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox24), 10);

  button_Basis = gtk_button_new ();
  gtk_widget_show (button_Basis);
  gtk_box_pack_start (GTK_BOX (hbox24), button_Basis, FALSE, FALSE, 0);

  alignment14 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment14);
  gtk_container_add (GTK_CONTAINER (button_Basis), alignment14);

  hbox25 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox25);
  gtk_container_add (GTK_CONTAINER (alignment14), hbox25);

  image14 = gtk_image_new_from_stock ("gtk-media-play", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image14);
  gtk_box_pack_start (GTK_BOX (hbox25), image14, FALSE, FALSE, 0);

  label41 = gtk_label_new_with_mnemonic (_("Basis"));
  gtk_widget_show (label41);
  gtk_box_pack_start (GTK_BOX (hbox25), label41, FALSE, FALSE, 0);

  button_Daten = gtk_button_new ();
  gtk_widget_show (button_Daten);
  gtk_box_pack_start (GTK_BOX (hbox24), button_Daten, FALSE, FALSE, 0);

  alignment32 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment32);
  gtk_container_add (GTK_CONTAINER (button_Daten), alignment32);

  hbox47 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox47);
  gtk_container_add (GTK_CONTAINER (alignment32), hbox47);

  image32 = gtk_image_new_from_stock ("gtk-media-play", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image32);
  gtk_box_pack_start (GTK_BOX (hbox47), image32, FALSE, FALSE, 0);

  label83 = gtk_label_new_with_mnemonic (_("Daten"));
  gtk_widget_show (label83);
  gtk_box_pack_start (GTK_BOX (hbox47), label83, FALSE, FALSE, 0);

  button_Ende = gtk_button_new_from_stock ("gtk-quit");
  gtk_widget_show (button_Ende);
  gtk_box_pack_start (GTK_BOX (hbox24), button_Ende, FALSE, FALSE, 0);

  g_signal_connect ((gpointer) button_Mittelwerte, "clicked",
                    G_CALLBACK (on_button_Mittelwerte_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_Standardabweichung, "clicked",
                    G_CALLBACK (on_button_Standardabweichung_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_Zeitmassstab, "clicked",
                    G_CALLBACK (on_button_Zeitmassstab_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_Laengenmassstab, "clicked",
                    G_CALLBACK (on_button_Laengenmassstab_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_Schubspannung, "clicked",
                    G_CALLBACK (on_button_Schubspannung_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_Schubspannungortho, "clicked",
                    G_CALLBACK (on_button_Schubspannungortho_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_Surfergeometrie, "clicked",
                    G_CALLBACK (on_button_Surfergeometrie_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_Basis, "clicked",
                    G_CALLBACK (on_button_Basis_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_Daten, "clicked",
                    G_CALLBACK (on_button_Daten_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_Ende, "clicked",
                    G_CALLBACK (gtk_main_quit),
                    NULL);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (window_Analyse, window_Analyse, "window_Analyse");
  GLADE_HOOKUP_OBJECT (window_Analyse, vbox9, "vbox9");
  GLADE_HOOKUP_OBJECT (window_Analyse, vbox10, "vbox10");
  GLADE_HOOKUP_OBJECT (window_Analyse, label_Analyse, "label_Analyse");
  GLADE_HOOKUP_OBJECT (window_Analyse, table15, "table15");
  GLADE_HOOKUP_OBJECT (window_Analyse, label_Mittelwerte, "label_Mittelwerte");
  GLADE_HOOKUP_OBJECT (window_Analyse, label_Fluktuation, "label_Fluktuation");
  GLADE_HOOKUP_OBJECT (window_Analyse, label_Zeitmassstab, "label_Zeitmassstab");
  GLADE_HOOKUP_OBJECT (window_Analyse, label_Laengenmassstab, "label_Laengenmassstab");
  GLADE_HOOKUP_OBJECT (window_Analyse, label_Schubspannung, "label_Schubspannung");
  GLADE_HOOKUP_OBJECT (window_Analyse, label_Pfad, "label_Pfad");
  GLADE_HOOKUP_OBJECT (window_Analyse, label_Pfad, "label_Pfad");
  GLADE_HOOKUP_OBJECT (window_Analyse, label_Pfad, "label_Pfad");
  GLADE_HOOKUP_OBJECT (window_Analyse, label_Pfad, "label_Pfad");
  GLADE_HOOKUP_OBJECT (window_Analyse, label_Pfad, "label_Pfad");
  GLADE_HOOKUP_OBJECT (window_Analyse, entry_Pfad_Mittelwerte, "entry_Pfad_Mittelwerte");
  GLADE_HOOKUP_OBJECT (window_Analyse, entry_Pfad_Standardabweichung, "entry_Pfad_Standardabweichung");
  GLADE_HOOKUP_OBJECT (window_Analyse, entry_Pfad_Zeitmassstab, "entry_Pfad_Zeitmassstab");
  GLADE_HOOKUP_OBJECT (window_Analyse, entry_Pfad_Laengenskale, "entry_Pfad_Laengenskale");
  GLADE_HOOKUP_OBJECT (window_Analyse, entry_Pfad_Schubspannung, "entry_Pfad_Schubspannung");
  GLADE_HOOKUP_OBJECT (window_Analyse, checkbutton_Autokorrel, "checkbutton_Autokorrel");
  GLADE_HOOKUP_OBJECT (window_Analyse, checkbutton_Tensor, "checkbutton_Tensor");
  GLADE_HOOKUP_OBJECT (window_Analyse, button_Mittelwerte, "button_Mittelwerte");
  GLADE_HOOKUP_OBJECT (window_Analyse, alignment17, "alignment17");
  GLADE_HOOKUP_OBJECT (window_Analyse, hbox28, "hbox28");
  GLADE_HOOKUP_OBJECT (window_Analyse, image17, "image17");
  GLADE_HOOKUP_OBJECT (window_Analyse, label56, "label56");
  GLADE_HOOKUP_OBJECT (window_Analyse, button_Standardabweichung, "button_Standardabweichung");
  GLADE_HOOKUP_OBJECT (window_Analyse, alignment18, "alignment18");
  GLADE_HOOKUP_OBJECT (window_Analyse, hbox29, "hbox29");
  GLADE_HOOKUP_OBJECT (window_Analyse, image18, "image18");
  GLADE_HOOKUP_OBJECT (window_Analyse, label57, "label57");
  GLADE_HOOKUP_OBJECT (window_Analyse, button_Zeitmassstab, "button_Zeitmassstab");
  GLADE_HOOKUP_OBJECT (window_Analyse, alignment19, "alignment19");
  GLADE_HOOKUP_OBJECT (window_Analyse, hbox30, "hbox30");
  GLADE_HOOKUP_OBJECT (window_Analyse, image19, "image19");
  GLADE_HOOKUP_OBJECT (window_Analyse, label58, "label58");
  GLADE_HOOKUP_OBJECT (window_Analyse, button_Laengenmassstab, "button_Laengenmassstab");
  GLADE_HOOKUP_OBJECT (window_Analyse, alignment20, "alignment20");
  GLADE_HOOKUP_OBJECT (window_Analyse, hbox31, "hbox31");
  GLADE_HOOKUP_OBJECT (window_Analyse, image20, "image20");
  GLADE_HOOKUP_OBJECT (window_Analyse, label59, "label59");
  GLADE_HOOKUP_OBJECT (window_Analyse, button_Schubspannung, "button_Schubspannung");
  GLADE_HOOKUP_OBJECT (window_Analyse, alignment21, "alignment21");
  GLADE_HOOKUP_OBJECT (window_Analyse, hbox32, "hbox32");
  GLADE_HOOKUP_OBJECT (window_Analyse, image21, "image21");
  GLADE_HOOKUP_OBJECT (window_Analyse, label60, "label60");
  GLADE_HOOKUP_OBJECT (window_Analyse, vbox11, "vbox11");
  GLADE_HOOKUP_OBJECT (window_Analyse, label_Ausgabe, "label_Ausgabe");
  GLADE_HOOKUP_OBJECT (window_Analyse, hbox33, "hbox33");
  GLADE_HOOKUP_OBJECT (window_Analyse, vbox15, "vbox15");
  GLADE_HOOKUP_OBJECT (window_Analyse, radiobutton_Mittelwerte, "radiobutton_Mittelwerte");
  GLADE_HOOKUP_OBJECT (window_Analyse, radiobutton_Standardabweichungen, "radiobutton_Standardabweichungen");
  GLADE_HOOKUP_OBJECT (window_Analyse, radiobutton_Zeitmassstab, "radiobutton_Zeitmassstab");
  GLADE_HOOKUP_OBJECT (window_Analyse, radiobutton_Laengenmassstab, "radiobutton_Laengenmassstab");
  GLADE_HOOKUP_OBJECT (window_Analyse, radiobutton_Schubspannung, "radiobutton_Schubspannung");
  GLADE_HOOKUP_OBJECT (window_Analyse, vbox13, "vbox13");
  GLADE_HOOKUP_OBJECT (window_Analyse, radiobutton_relativ, "radiobutton_relativ");
  GLADE_HOOKUP_OBJECT (window_Analyse, radiobutton_absolut, "radiobutton_absolut");
  GLADE_HOOKUP_OBJECT (window_Analyse, radiobutton_absrel, "radiobutton_absrel");
  GLADE_HOOKUP_OBJECT (window_Analyse, button_Surfergeometrie, "button_Surfergeometrie");
  GLADE_HOOKUP_OBJECT (window_Analyse, alignment22, "alignment22");
  GLADE_HOOKUP_OBJECT (window_Analyse, hbox34, "hbox34");
  GLADE_HOOKUP_OBJECT (window_Analyse, image22, "image22");
  GLADE_HOOKUP_OBJECT (window_Analyse, label67, "label67");
  GLADE_HOOKUP_OBJECT (window_Analyse, hbox24, "hbox24");
  GLADE_HOOKUP_OBJECT (window_Analyse, button_Basis, "button_Basis");
  GLADE_HOOKUP_OBJECT (window_Analyse, alignment14, "alignment14");
  GLADE_HOOKUP_OBJECT (window_Analyse, hbox25, "hbox25");
  GLADE_HOOKUP_OBJECT (window_Analyse, image14, "image14");
  GLADE_HOOKUP_OBJECT (window_Analyse, label41, "label41");
  GLADE_HOOKUP_OBJECT (window_Analyse, button_Daten, "button_Daten");
  GLADE_HOOKUP_OBJECT (window_Analyse, alignment32, "alignment32");
  GLADE_HOOKUP_OBJECT (window_Analyse, hbox47, "hbox47");
  GLADE_HOOKUP_OBJECT (window_Analyse, image32, "image32");
  GLADE_HOOKUP_OBJECT (window_Analyse, label83, "label83");
  GLADE_HOOKUP_OBJECT (window_Analyse, button_Ende, "button_Ende");

  return window_Analyse;
}
