/**************************************Laengenskale*************************************************/
/*	Programm zur Bestimmung der makroturbulenten Laengenskale unter Vorraussetzung der Taylor-
	Hypothese aus den turbulenten Zeitskalen.
	Ausgabeformat: y- z-Koordinate Laengenskale in u- v- w-Richtung
	Eingabedateien sind die Datei der integralen Zeitskale (Vgl. Autokorrel) die Mittelwertdatei
	(Vgl. Mittelwerte)									     */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

#define PFAD 256
#define DAT 200

/*	Hauptprogramm mit Argumenten aus dem Projekt ADDV	*/

main(int argc, char *argv[]){

	FILE *eingabe1, *eingabe2, *ausgabe;
	char kot_pfad[PFAD],tz_pfad[PFAD],ld_pfad[PFAD];
	char kot_zeile[DAT],tz_zeile[DAT];
	double y,z,z2,vx,vy,vz,tx,ty,tz,lx,ly,lz;

	sprintf(kot_pfad,"%s",argv[1]);
	strcat(kot_pfad,".kot");
	eingabe1=fopen(kot_pfad,"r");		//Oeffnen der Datei mit den Mittelwerten der transformierten Geschwindigkeitswerte
	
	sprintf(tz_pfad,"%s",argv[2]);
	strcat(tz_pfad,".tz");
	eingabe2=fopen(tz_pfad,"r");		//Oeffnen der Datei mit den integralen Zeitskalen
	
	sprintf(ld_pfad,"%s",argv[3]);
	strcat(ld_pfad,".ld");
	ausgabe=fopen(ld_pfad,"w");		//Anlegen der neuen Datei mit den makroturbulenten Laengenskalen
	
	while(!feof(eingabe1)){
		fgets(kot_zeile,200,eingabe1);
		if(!feof(eingabe1)){
			sscanf(kot_zeile,"%lf%lf%lf%lf%lf",&y,&z,&vx,&vy,&vz);
			fgets(tz_zeile,200,eingabe2);
			sscanf(tz_zeile,"%lf%lf%lf%lf%lf",&y,&z2,&tx,&ty,&tz);
			lx=vx*tx*0.01;			//Berechnung der makroturbulenten Laengenskale als Produkt aus Zeitskale x Mittelwert
			ly=vy*ty*0.01;
			lz=vz*tz*0.01;
			fprintf(ausgabe,"%lf\t%lf\t%lf\t%lf\t%lf\n",y,z,lx,ly,lz);
		}
	}
	fclose(eingabe1);
	fclose(eingabe2);
	fclose(ausgabe);
}	
