/*****************************************Standardabweichung*************************************************/

/*	Programm zur Berechnung der Standardabweichungen der drei Geschwindigkeitsfluktuationen bez. Ge-
	schwindigkeitswerte. Uebliche Bezeichnung ist die Turbulenzintensitaet (nicht normiert) oder r.m.s.-Wert
	 der Fluktuationen 
	Die Ausgabedatei Standardabw.txt beinhaltet das Format: y- z-Koordinate Standardabweichungen in u- v-
	w-Richtung. 
	ACHTUNG: u v w in x y z -Richtung								    */

#include<stdio.h>
#include<string.h>
#include<math.h>
#include<stdlib.h>

#define PFAD_LAENGE 255
#define ZEILEN_LAENGE 250

/*	Hauptprogramm mit Argumenten aus dem Projekt ADDV	*/

main(int argc, char *argv[]){
	
	FILE *eingabe1, *eingabe2, *ausgabe;
	char pfad[PFAD_LAENGE], zielpfad[PFAD_LAENGE], y_pfad[PFAD_LAENGE],zy_pfad[PFAD_LAENGE];
	char lamellenordner[5], lamellenpkt[5], tp_datei[PFAD_LAENGE], kot_datei[PFAD_LAENGE];
	char tp_zeile[ZEILEN_LAENGE], kot_zeile[ZEILEN_LAENGE];
	double t, y, z, u_mittel, v_mittel, w_mittel, SumSqDiff_u, SumSqDiff_v, SumSqDiff_w, u, v, w;
	double stabw_u, stabw_v, stabw_w, K;
	int i,j,k,l,n=9,m=25, anzahl, weiter;
	
	sprintf(pfad,"%s",argv[1]);						/* Einlesen des Ordners */
	
	sprintf(zielpfad,"%s",argv[2]);						/* Einlesen des Zielpfades */
	
	strcat(zielpfad,".std");
	ausgabe=fopen(zielpfad,"w");
	
	sprintf(kot_datei,"%s",argv[3]);						/* Einlesen des Mittelwertpfades */
	strcat(kot_datei,".kot");
	
	eingabe1=fopen(kot_datei,"r");
		
	for(i=0;i<=m;i++){						/* Schleife fuer 1. Lamellenwert */
	
		for(j=0;j<=n;j++){					/* Schleife fuer 2. Lamellenwert */
		for(k=0;k<=n;k++){					/* Schleife fuer 3. Lamellenwert (Zweite Nachkommastelle) */
		
			strcpy(y_pfad,pfad);				/* Kopieren und Ueberschreiben des y-zielpfad mit zielpfad */
			sprintf(lamellenordner,"/%i_%i%i",i,j,k);
			strcat(y_pfad,lamellenordner);			/* Lamellenordner an Pfad anhaengen */
			
			
			for(l=1;l<=m;l++){				/* Schleife fuer Lamellenpunkt */ 
			
				strcpy(zy_pfad,y_pfad);			/* Kopieren bzw. Ueberschreiben des zypfad mit ypfad */
				sprintf(lamellenpkt,"/%i",l);
				strcat(zy_pfad,lamellenpkt);		/* Messpunkt an Pfad anhaengen */
				strcpy(tp_datei,zy_pfad);
				strcat(tp_datei,".tp");
			
				eingabe2=fopen(tp_datei,"r");		/* Oeffnen der tp.-Datei */
				
				if(eingabe2!=NULL){
					
					anzahl=0;
					SumSqDiff_u=0;
					SumSqDiff_v=0;
					SumSqDiff_w=0;
					
					fgets(kot_zeile,250,eingabe1);
					sscanf(kot_zeile,"%lf%lf%lf%lf%lf",&y,&z,&u_mittel,&v_mittel,&w_mittel);
					
					//v_mittel=0;		// Fuer Querschnittsmittelbetrachtung
					//w_mittel=0;		// Fuer Querschnittsmittelbetrachtung
					
					while(!feof(eingabe2)){
						fgets(tp_zeile,250,eingabe2);
						weiter=feof(eingabe2);
						if(weiter==0){
							sscanf(tp_zeile,"%lf%lf%lf%lf%lf%lf",&t,&y,&z,&u,&v,&w);
							SumSqDiff_u+=(u*0.01-u_mittel*0.01)*(u*0.01-u_mittel*0.01);	//Aufsummieren quadrierter Fluktuationen
							SumSqDiff_v+=(v*0.01-v_mittel*0.01)*(v*0.01-v_mittel*0.01);
							SumSqDiff_w+=(w*0.01-w_mittel*0.01)*(w*0.01-w_mittel*0.01);
							}
						anzahl++;					//Zaehlen der Messwerte
					}
					
					stabw_u=sqrt(SumSqDiff_u/(anzahl-1));			//Berechnung der Standardabweichung
					stabw_v=sqrt(SumSqDiff_v/(anzahl-1));
					stabw_w=sqrt(SumSqDiff_w/(anzahl-1));
					K=0.5*((SumSqDiff_u/(anzahl-1))+(SumSqDiff_v/(anzahl-1))+(SumSqDiff_w/(anzahl-1)));	/* Berechnung der kinetischen Energie der
																Fluktuationen */
					
					fprintf(ausgabe,"%lf\t%lf\t%lf\t%lf\t%lf\t%lf\n",y,z,stabw_u,stabw_v,stabw_w,sqrt(K));	//Schreiben der Ergebniswerte
					
					fclose(eingabe2);
				}
			}
		}
		}
	}
	fclose(ausgabe);
	fclose(eingabe1);
}
