/*******************************************************************************SURFERGEOMETRIE**************************************************************************/

/*	!!!!!!!!!!!!!!!!!!!!!!!!ANWEISUNGEN ZUR VERAENDERUNG DES C-CODES BEI BESONDERHEITEN SIND IM KOMMENTAR GROSS GESCHRIEBEN!!!!!!!!!!!!!!!!!!!!!!!!!!!		*/
/* 	Programm zur Bildung von Punktmittel-Dateien mit Koordinaten der Vermessung: Zur Einlesung und Erstellen von Surferplots. Abweichend von "rechter 				Hand"-Koordinatensystem sind z die absoluten Hoehenkoten ue. HN und y nach rechts positiv definiert. Sollte Programm auf Messungen vom rechten Ufer aus angewendet 		werden, so sind ACHTUNG: +/- an gekennzeichneten Stellen zu tauschen. Naehere Informationen zu den Dateien in Surfer (Golden Software, 1999).
	Eingabe: y-Koordinate (vom Uferpunkt) z-Koordinate (relativ zur Sohle der entsprechenden Lamelle)  bis zu 6 Datenspalten sowie Profildateien Der Vermessung
	Ausgabe: Dateien mit absoluten y-z-Koordinaten (von Vermessungsfestpunkt/ Hoehennetz HN) und relativen y/B- und z/H- Werten
	sowie den Blankdateien zum Abgrenzen nicht zum Profil gehöriger Bereiche 											*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define MAX 600

/*	Hauptprogramm mit Datei- und Ausgabevorgaben aus den Argumenten des Projektes ADDV	*/

main(int argc, char *argv[]){
	
	FILE *eingabe1, *eingabe2, *eingabe3, *ausgabe1, *ausgabe2, *ausgabe3;
	
	char datei_daten[MAX],datei_vermessung[MAX],datei_out[MAX],datei_txt[MAX],datei_bln[MAX],zeile[200],datenpfad[200];
	char datei_reltxt[MAX],datei_break[MAX],datei_relbreak[MAX],datei_relbln[MAX],komma,muell[156],datenzeile[200];
	int i=1,j=1,k=0,n=0,m=0,spalten,zusatz, bezug;
	double y[MAX],z[MAX],ygeo[MAX],zgeo[MAX],a[MAX],b[MAX],c[MAX],d[MAX],e[MAX],f[MAX],z_l[25],dz_wsp,y_neu,z_neu,z_s;
	double yl,yr,y_grenze_li,y_grenze_re,z_grenze_li,z_grenze_re,grenze_li,grenze_re,yl1=0.0,yr1=0.0;
	double y_plus[25],z_plus[25],y_min,y_max,z_min,z_max,faktor,d1,d2,d3,d4,d5,d6;
	double dy,dz_verm_wsp,dz_mp_wsp,z_wsp;
	
	double y_abw1=7.31;	//Besonderheit: Nachtraegliche Hoehenkorrektur, wenn oberster gemessener Lamellenpkt entfernt wurde -> EINGABE der Lamelle in m.cm!
	double dz_abw=7.0;	//Korrekturwert (= Abstand zum darunter liegenden naechsten Messpunkt) zum Wasserspiegel -> EINGABE in cm.mm!
	double test_abw;
	
	sprintf(datei_daten,"%s",argv[1]);				//Einagbe zu oeffnender und auszugebender Dateien
	eingabe1=fopen(datei_daten,"r");
	
	sprintf(datei_vermessung,"%s",argv[2]);
	eingabe2=fopen(datei_vermessung,"r");
	
	sprintf(datei_out,"%s",argv[3]);
	strcpy(datei_txt,datei_out);
	strcat(datei_txt,".txt");
	ausgabe1=fopen(datei_txt,"w");
	strcpy(datei_bln,datei_out);
	strcat(datei_bln,".bln");
	ausgabe2=fopen(datei_bln,"w");
	
	sprintf(datenpfad,"%s",argv[4]);
	eingabe3=fopen(datenpfad,"r");
	fgets(datenzeile,200,eingabe3);
	sscanf(datenzeile,"%s%lf%lf%lf%lf%lf",&muell,&dz_verm_wsp,&dy,&y_grenze_li,&y_grenze_re,&dz_mp_wsp);	//Daten aus der Grunddatei des ADDV-Projektes mit Profildaten
	faktor=atof(argv[5]);	//Veraenderung der Eingangswerte z.B. [cm] => [m]?
	bezug=atoi(argv[6]);	//Relative Darstellung?
	zusatz=atoi(argv[7]);	//Erweiterung der Eingangswerte fr Sohle und Wasserspiegel?
	
// Einlesen Punktmittel-Datei + Festhalten der groessten Lamellen-z-Werte
	
	while(!feof(eingabe1)){					//Einlesen der Datei mit den darzustellenden Ergebnissen
		fgets(zeile,200,eingabe1);
		if(!feof(eingabe1)){
			spalten=sscanf(zeile,"%lf%lf%lf%lf%lf%lf%lf%lf",&y[i],&z[i],&d1,&d2,&d3,&d4,&d5,&d6);
			a[i]=d1*faktor;b[i]=d2*faktor;c[i]=d3*faktor;d[i]=d4*faktor;e[i]=d5*faktor;f[i]=d6*faktor;
			if(i>1&&y[i]>y[i-1]){		//Lamellenwechsel?
				z_l[j]=z[i-1];		//Festhalten des z-Wertes des Wasserspiegels der vorigen Lamelle
				j++;			//Zahler der Lamellen
			}
			n++;			//Zaehler aller Punkte
			i++;
		}
	}
	z_l[j]=z[n];			//Letzter z - Wasserspiegelwert
	fclose(eingabe1);
	
// Einlesen des Vermessungsprofils
	
	i=1;
	while(!feof(eingabe2)){
		fgets(zeile,200,eingabe2);
		if(!feof(eingabe2)){
			sscanf(zeile,"%lf%lf",&ygeo[i],&zgeo[i]);
			m++;
			i++;
			}
	}
	fclose(eingabe2);
	
// Berechnung der Wasserspiegel-z-Kote und y-Uferpunkte im neuen KO-System
	
	z_wsp=zgeo[1]-dz_verm_wsp;
	grenze_li=y[1]+dy-y_grenze_li;		// 			ACHTUNG: +/-
	//grenze_li=y[n]+dy+y_grenze_li;
	grenze_re=y[n]+dy+y_grenze_re;		// 			ACHTUNG: +/-
	//grenze_re=y[1]+dy-y_grenze_re;
	
// Schreiben der Grid- und Blank-Datei
	
	j=1;
	for(i=1;i<=n;i++){
test_abw=sqrt((y[i]-y_abw1)*(y[i]-y_abw1));	// Test, ob bei der Lamelle Besonderheiten vorliegen; Unter Beachtung numerischer Rundungsfehler
		y_neu=y[i]+dy;						//Berechnung neuer y-Koordinate
		z_neu=z_wsp-(z_l[j]+dz_mp_wsp-z[i])/100.0;	//Berechnung der neun Z-Koordinate "von oben"
		z_s=z_wsp-(z_l[j]+dz_mp_wsp)/100.0;		
if(test_abw<0.01){						//Lamelle, in dem oberster Messpunkt fehlt und Distanz ergaenzt werden muss
	z_neu=z_wsp-(z_l[j]+dz_abw+dz_mp_wsp-z[i])/100.0;
	z_s=z_wsp-(z_l[j]+dz_abw+dz_mp_wsp)/100.0;
}

// Schreiben der Zeilen mit neuen Koordinaten

		if(spalten==3)	fprintf(ausgabe1,"%lf\t%lf\t%lf\n",y_neu,z_neu,a[i]);
		if(spalten==4)	fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\n",y_neu,z_neu,a[i],b[i]);
		if(spalten==5)	fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\t%lf\n",y_neu,z_neu,a[i],b[i],c[i]);
		if(spalten==6)	fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\t%lf\t%lf\n",y_neu,z_neu,a[i],b[i],c[i],d[i]);
		if(spalten==7)	fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\n",y_neu,z_neu,a[i],b[i],c[i],d[i],e[i]);
		if(spalten==8)	fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\n",y_neu,z_neu,a[i],b[i],c[i],d[i],e[i],f[i]);
		
		if(i<n&&y[i+1]>y[i]||i==n){
			if(spalten==3&&zusatz==1){
				fprintf(ausgabe1,"%lf\t%lf\t%lf\n",y_neu,z_s,0.0);
				fprintf(ausgabe1,"%lf\t%lf\t%lf\n",y_neu,z_wsp,a[i]);
			}
			if(spalten==4&&zusatz==1){
				fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\n",y_neu,z_s,0.0,0.0);
				fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\n",y_neu,z_wsp,a[i],b[i]);
			}
			if(spalten==5&&zusatz==1){
				fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\t%lf\n",y_neu,z_s,0.0,0.0,0.0);
				fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\t%lf\n",y_neu,z_wsp,a[i],b[i],c[i]);
			}
			if(spalten==6&&zusatz==1){
				fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\t%lf\t%lf\n",y_neu,z_s,0.0,0.0,0.0,0.0);
				fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\t%lf\t%lf\n",y_neu,z_wsp,a[i],b[i],c[i],d[i]);
			}
			if(spalten==7&&zusatz==1){
				fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\n",y_neu,z_s,0.0,0.0,0.0,0.0,0.0);
				fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\n",y_neu,z_wsp,a[i],b[i],c[i],d[i],e[i]);
			}
			if(spalten==8&&zusatz==1){
				fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\n",y_neu,z_s,0.0,0.0,0.0,0.0,0.0,0.0);
				fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\n",y_neu,z_wsp,a[i],b[i],c[i],d[i],e[i],f[i]);
			}
			y_plus[j]=y_neu;
			z_plus[j]=z_s;
			j++;
		}
	}
// Zaehlen der Wertepaare für die Blank-Datei
	for(i=2;i<=m;i++){
		if(zgeo[i]<z_wsp) k++;				//wenn Vermessungs-Profilpunkt unter der Wasseroberfläche
		if(zgeo[i]>z_wsp&&zgeo[i-1]<z_wsp) k++;			//wenn Wechsel von Wasser- zu Landpunkt
		if(i<m&&(zgeo[i]>z_wsp&&zgeo[i+1]<z_wsp)) k++;		//von Land- zu Wasserpunkt
	}
// Schreiben in Blank- und Text-Datei
	fprintf(ausgabe2,"%i,%i\n",k+j,0);	//Eingabe der Punktanzahl in Blank-Datei (Zu Ufer- und Vermessungs-Profilpunkte werden Lammellenanzahl zuaddiert
	j=1;
	for(i=2;i<=m;i++){				//Schreiben des Uferpunktes links mit 0-Werten!
		if(zgeo[i-1]>z_wsp&&zgeo[i]<z_wsp){
			yl=ygeo[i-1]+(ygeo[i]-ygeo[i-1])/(zgeo[i]-zgeo[i-1])*(z_wsp-zgeo[i-1]);
			if(yl1==0.0) yl1=yl;
			fprintf(ausgabe2,"%lf,%lf\n",yl,z_wsp);
			if(spalten==3)	fprintf(ausgabe1,"%lf\t%lf\t%lf\n",yl,z_wsp,0.0);
			if(spalten==4)	fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\n",yl,z_wsp,0.0,0.0);
			if(spalten==5)	fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\t%lf\n",yl,z_wsp,0.0,0.0,0.0);
			if(spalten==6)	fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\t%lf\t%lf\n",yl,z_wsp,0.0,0.0,0.0,0.0);
			if(spalten==7)	fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\n",yl,z_wsp,0.0,0.0,0.0,0.0,0.0);
			if(spalten==8)	fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\n",yl,z_wsp,0.0,0.0,0.0,0.0,0.0,0.0);
		}
		if(ygeo[i-1]<=y_plus[j]&&ygeo[i]>y_plus[j]){		//Schreiben eines Lamellenpunkte in Blank-Datei
			fprintf(ausgabe2,"%lf,%lf\n",y_plus[j],z_plus[j]);
			j++;
		}
		if(zgeo[i]<z_wsp) fprintf(ausgabe2,"%lf,%lf\n",ygeo[i],zgeo[i]);	//Schreiben eines Wasserpunktes in Blank-Datei
		if(zgeo[i-1]<z_wsp&&zgeo[i]>z_wsp){			// Schreiben des Uferpunktes rechts mit 0-Werten!
			yr=ygeo[i-1]+(ygeo[i]-ygeo[i-1])/(zgeo[i]-zgeo[i-1])*(z_wsp-zgeo[i-1]);
			if(yr1==0.0) yr1=yr;
			fprintf(ausgabe2,"%lf,%lf\n",yr,z_wsp);
			if(spalten==3)	fprintf(ausgabe1,"%lf\t%lf\t%lf\n",yr,z_wsp,0.0);
			if(spalten==4)	fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\n",yr,z_wsp,0.0,0.0);
			if(spalten==5)	fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\t%lf\n",yr,z_wsp,0.0,0.0,0.0);
			if(spalten==6)	fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\t%lf\t%lf\n",yr,z_wsp,0.0,0.0,0.0,0.0);	
			if(spalten==7)	fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\n",yr,z_wsp,0.0,0.0,0.0,0.0,0.0);
			if(spalten==8)	fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\n",yr,z_wsp,0.0,0.0,0.0,0.0,0.0,0.0);
		}
// Bestimmung der z-Koordinaten der Grenze zu abflussunwirksamen Teilquerschnitt
		if(ygeo[i-1]<grenze_li&&ygeo[i]>grenze_li)			
			z_grenze_li=zgeo[i-1]+(zgeo[i]-zgeo[i-1])/(ygeo[i]-ygeo[i-1])*(grenze_li-ygeo[i-1]);
		if(ygeo[i-1]<grenze_re&&ygeo[i]>grenze_re)
			z_grenze_re=zgeo[i-1]+(zgeo[i]-zgeo[i-1])/(ygeo[i]-ygeo[i-1])*(grenze_re-ygeo[i-1]);
	}
	fprintf(ausgabe2,"%lf,%lf\n",yl1,z_wsp);		// Erste Punkt muss zum Schluss wiederholt werden, damit Polygon geschlossen ist
	//fprintf(ausgabe2,"%lf,%lf\n",yr1,z_wsp);		//		ACHTUNG: +/-
	fclose(ausgabe1);
	fclose(ausgabe2);
	
// Schreiben der Breakline-Datei - Zur Abgrenzung nicht-abflusswirksamer Teilfläche bei Integration der Informationen
	
	if(y_grenze_li!=0.0||y_grenze_re!=0.0){
		strcpy(datei_break,datei_out);
		strcat(datei_break,"breaklines.bln");
		ausgabe3=fopen(datei_break,"w");
		if(y_grenze_li!=0.0){
			fprintf(ausgabe3,"%i\n",2);
			fprintf(ausgabe3,"%lf,%lf,%lf\n",grenze_li,z_grenze_li,0.0);
			fprintf(ausgabe3,"%lf,%lf,%lf\n",grenze_li,z_wsp,0.0);
		}
		if(y_grenze_re!=0.0){
			fprintf(ausgabe3,"%i\n",2);
			fprintf(ausgabe3,"%lf,%lf,%lf\n",grenze_re,z_grenze_re,0.0);
			fprintf(ausgabe3,"%lf,%lf,%lf\n",grenze_re,z_wsp,0.0);
		}
		fclose(ausgabe3);
	}
	
	if(bezug==1) exit(0);
	
// Schreiben der relativen Datensaetze - s.o. mit relativen Bezug
	
	eingabe1=fopen(datei_txt,"r");
	eingabe2=fopen(datei_bln,"r");
	strcpy(datei_reltxt,datei_out);
	strcat(datei_reltxt,"rel.txt");
	ausgabe1=fopen(datei_reltxt,"w");
	strcpy(datei_relbln,datei_out);
	strcat(datei_relbln,"rel.bln");
	ausgabe2=fopen(datei_relbln,"w");
	i=1; n=0;
	while(!feof(eingabe1)){
		fgets(zeile,200,eingabe1);
		if(!feof(eingabe1)){
			spalten=sscanf(zeile,"%lf%lf%lf%lf%lf%lf%lf",&y[i],&z[i],&a[i],&b[i],&c[i],&d[i],&e[i]);
			if(i==1) z_min=z[i];
			if(i>1&&(z[i]<z_min)) z_min=z[i];
			if(i>1&&(y[i]<y[i-1])) y_min=y[i];
			y_max=y[i];
			z_max=z[i];
		}
		i++;
		n++;
	}
	for(i=1;i<n;i++){
		y_neu=(y[i]-y_min)/(y_max-y_min);
		z_neu=(z[i]-z_min)/(z_max-z_min);
		if(spalten==3) fprintf(ausgabe1,"%lf\t%lf\t%lf\n",y_neu,z_neu,a[i]);
		if(spalten==4) fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\n",y_neu,z_neu,a[i],b[i]);
		if(spalten==5) fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\t%lf\n",y_neu,z_neu,a[i],b[i],c[i]);
		if(spalten==6) fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\t%lf\t%lf\n",y_neu,z_neu,a[i],b[i],c[i],d[i]);
		if(spalten==7) fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\n",y_neu,z_neu,a[i],b[i],c[i],d[i],e[i]);
		if(spalten==8) fprintf(ausgabe1,"%lf\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\n",y_neu,z_neu,a[i],b[i],c[i],d[i],e[i],f[i]);
	}
	i=1;
	while(!feof(eingabe2)){
		fgets(zeile,200,eingabe2);
		if(i==1){
			sscanf(zeile,"%i%c%i",&k,&komma,&j);
			fprintf(ausgabe2,"%i,%i\n",k,j);
		}
		if(!feof(eingabe2)&&i>1){
			sscanf(zeile,"%lf%c%lf",&y[i],&komma,&z[i]);
			y_neu=(y[i]-y_min)/(y_max-y_min);
			z_neu=(z[i]-z_min)/(z_max-z_min);
			fprintf(ausgabe2,"%lf,%lf\n",y_neu,z_neu);
		}
		i++;
	}
	fclose(eingabe1);
	fclose(ausgabe1);
	fclose(eingabe2);
	fclose(ausgabe2);
	
	if(y_grenze_li!=0.0||y_grenze_re!=0.0){
	strcpy(datei_relbreak,datei_out);
	strcat(datei_relbreak,"relbreaklines.bln");
	ausgabe3=fopen(datei_relbreak,"w");
	if(y_grenze_li!=0.0){
		fprintf(ausgabe3,"%i\n",2);
		fprintf(ausgabe3,"%lf,%lf,%lf\n",(grenze_li-y_min)/(y_max-y_min),(z_grenze_li-z_min)/(z_max-z_min),0.0);
		fprintf(ausgabe3,"%lf,%lf,%lf\n",(grenze_li-y_min)/(y_max-y_min),1.0,0.0);
	}
	if(y_grenze_re!=0.0){
		fprintf(ausgabe3,"%i\n",2);
		fprintf(ausgabe3,"%lf,%lf,%lf\n",(grenze_re-y_min)/(y_max-y_min),(z_grenze_re-z_min)/(z_max-z_min),0.0);
		fprintf(ausgabe3,"%lf,%lf,%lf\n",(grenze_re-y_min)/(y_max-y_min),1.0,0.0);
	}
	fclose(ausgabe3);
	}
	if(bezug==0){
		remove(datei_break);
		remove(datei_txt);
		remove(datei_bln);
	}
}
