/*****************************************************************TAUVERTEILUNG*****************************************************************/

/* 	Programm zur Berechnung der (turbulenten) Schubspannungsverteilung in einem Profilquerschnitt. 
	Format der Ausgabedatei: y-  z-Koordinate  Schubspannung Reynolds- (2D)  nach turbulent kinetischer Energiemethode
		wahlweise Ausgabe des Reynoldsspannungstensors mit: y-  z-Koordinate Normalspannungen: -uu -vv -ww Schubspannungen -uv -uw -vw und
				zusätzlich advektiven Spannungen: -um*vm  - um*wm  -vm*wm	(jeweils mit Dichte des Wassers multipliziert)	 
	ACHTUNG: Bei Umstellung von 2D - 3D ADV: ANWEISUNG: 2D/3D!!!										*/


#include<stdio.h>
#include<string.h>
#include<math.h>
#include<stdlib.h>

#define PFAD_LAENGE 255
#define ZEILEN_LAENGE 250

/*	Hauptprogramm mit Argumenten aus dem Projekt ADDV	*/

main(int argc, char *argv[]){
	
	
	FILE *eingabe1, *eingabe2, *ausgabe, *ausgabe2;
	char pfad[PFAD_LAENGE], zielpfad[PFAD_LAENGE], y_pfad[PFAD_LAENGE],zy_pfad[PFAD_LAENGE];
	char lamellenordner[5], lamellenpkt[5], tp_datei[PFAD_LAENGE], txt_datei[PFAD_LAENGE], kot_datei[PFAD_LAENGE];
	char tp_zeile[ZEILEN_LAENGE], kot_zeile[ZEILEN_LAENGE], ten_datei[PFAD_LAENGE];
	double t, y, z, u_mittel, v_mittel, w_mittel, SumSqDiff_u, SumSqDiff_v, SumSqDiff_w,ProdDiff_uw,ProdDiff_uv,ProdDiff_vw, u, v, w;
	double var_u, var_v, var_w,tau_uu,tau_vv,tau_ww,tau_uv,tau_vw,tau_uw, C_STAPHUN=0.19, tau_COV, tau_TKE,  rho_w=1000.0;
	double Prod_uv, Prod_uw, Prod_vw, tau_uvm,tau_uwm,tau_vwm;
	int i,j,k,l,n=9,m=25, anzahl, weiter,frage_tensor;
	
	sprintf(pfad,"%s",argv[1]);						/* Einlesen des Ordners */
	
	sprintf(zielpfad,"%s",argv[2]);						/* Einlesen des Zielpfades */
	
	strcpy(txt_datei,zielpfad);
	strcat(txt_datei,".tau");
	
	ausgabe=fopen(txt_datei,"w");
	
	frage_tensor=atoi(argv[3]);					// Tensorausgabe ja/nein?
	
	if(frage_tensor==1){
		strcpy(ten_datei,zielpfad);
		strcat(ten_datei,".ten");
		
		ausgabe2=fopen(ten_datei,"w");
	}
	
	strcpy(kot_datei,pfad);
	strcat(kot_datei,"/Punktmittel.kot");
	
	eingabe1=fopen(kot_datei,"r");					//Oeffnen der Mittelwertdatei
		
	for(i=0;i<=m;i++){						/* Schleife fuer 1. Lamellenwert */
	
		for(j=0;j<=n;j++){					/* Schleife fuer 2. Lamellenwert */
		for(k=0;k<=n;k++){					/* Schleife fuer 3. Lamellenwert (Zweite Nachkommastelle) */
		
			strcpy(y_pfad,pfad);				/* Kopieren und Ueberschreiben des y-zielpfad mit zielpfad */
			sprintf(lamellenordner,"/%i_%i%i",i,j,k);
			strcat(y_pfad,lamellenordner);			/* Lamellenordner an Pfad anhaengen */
			
			
			for(l=1;l<=m;l++){				/* Schleife fuer Lamellenpunkt */ 
			
				strcpy(zy_pfad,y_pfad);			/* Kopieren bzw. Ueberschreiben des zypfad mit ypfad */
				sprintf(lamellenpkt,"/%i",l);
				strcat(zy_pfad,lamellenpkt);		/* Messpunkt an Pfad anhaengen */
				strcpy(tp_datei,zy_pfad);
				strcat(tp_datei,".tp");
			
				eingabe2=fopen(tp_datei,"r");		/* Oeffnen der Punktgeschwindigkeiten-Datei */
				
				if(eingabe2!=NULL){
					
					anzahl=0;
					SumSqDiff_u=0.0;		// Startwerte (0) der Summen und Produkte
					SumSqDiff_v=0.0;
					SumSqDiff_w=0.0;
					ProdDiff_uv=0.0;
					ProdDiff_uw=0.0;
					ProdDiff_vw=0.0;
					
					fgets(kot_zeile,250,eingabe1);
					sscanf(kot_zeile,"%lf%lf%lf%lf%lf",&y,&z,&u_mittel,&v_mittel,&w_mittel);	//Einlesen der Mittelwerte
					
					//v_mittel=0;		// Fuer Querschnittsmittelbetrachtung und Sekundaerstroemungseinfluss
					//w_mittel=0;		
					
					Prod_uv=(u_mittel*0.01)*(v_mittel*0.01);		// Produkte der Mittelwerte (Sekundaerstroemungen)
					Prod_uw=(u_mittel*0.01)*(w_mittel*0.01);
					Prod_vw=(v_mittel*0.01)*(w_mittel*0.01);

					while(!feof(eingabe2)){
						fgets(tp_zeile,250,eingabe2);
						weiter=feof(eingabe2);
						if(weiter==0){
							sscanf(tp_zeile,"%lf%lf%lf%lf%lf%lf",&t,&y,&z,&u,&v,&w);     // Einlesen der Geschwindigkeiten (Momentanwerte)
							SumSqDiff_u+=(u*0.01-u_mittel*0.01)*(u*0.01-u_mittel*0.01);  // Aufsummieren der Geschwindigquadrate (Fluktuationen)
							SumSqDiff_v+=(v*0.01-v_mittel*0.01)*(v*0.01-v_mittel*0.01);
							SumSqDiff_w+=(w*0.01-w_mittel*0.01)*(w*0.01-w_mittel*0.01);
							ProdDiff_uv+=(u*0.01-u_mittel*0.01)*(v*0.01-v_mittel*0.01);  // Aufsummieren der Geschwindigkeitsprodukte (Fluktuationen)
							ProdDiff_uw+=(u*0.01-u_mittel*0.01)*(w*0.01-w_mittel*0.01);
							ProdDiff_vw+=(v*0.01-v_mittel*0.01)*(w*0.01-w_mittel*0.01);
							anzahl++;
							}
						
					}
					
					var_u=(SumSqDiff_u/(anzahl-1));			// Varianz der Geschwindigkeitsfluktuationen
					var_v=(SumSqDiff_v/(anzahl-1));
					var_w=(SumSqDiff_w/(anzahl-1));
					
					//tau_COV=-rho_w*ProdDiff_uv/anzahl;	//2D-ADV
					tau_COV=-rho_w*ProdDiff_uw/anzahl;	// 3D-ADV			2D-Reynoldsschubspannung
					tau_TKE=0.5*rho_w*C_STAPHUN*(var_u+var_v+var_w);	//3D-ADV	Schubspannnung nach TKE
					
					tau_uu=-var_u*rho_w;			// Normalspannungen
					tau_vv=-var_v*rho_w;
					tau_ww=-var_w*rho_w;
					tau_uv=-ProdDiff_uv/anzahl*rho_w;	// Schubspannungen
					tau_uw=-ProdDiff_uw/anzahl*rho_w;
					tau_vw=-ProdDiff_vw/anzahl*rho_w;
					tau_uvm=-Prod_uv*rho_w;			// advektive Spannungen
					tau_uwm=-Prod_uw*rho_w;
					tau_vwm=-Prod_vw*rho_w;
				
					// Ausgabe
					//fprintf(ausgabe,"%lf\t%lf\t%lf\t%lf\n",y,z,tau_COV,tau_uvm);			//2D-ADV
					fprintf(ausgabe,"%lf\t%lf\t%lf\t%lf\t%lf\n",y,z,tau_COV,tau_uwm,tau_TKE);	//3D-ADV
					if(frage_tensor==1){ 
					//fprintf(ausgabe2,"%lf %lf Normal: %lf %lf Reynolds: %lf Advektion: %lf\n",y,z,tau_uu,tau_vv,tau_uv,tau_uvm);	//2D-ADV
					fprintf(ausgabe2,"%lf %lf Normal: %lf %lf %lf Reynolds: %lf %lf %lf Advektion: %lf %lf %lf\n",y,z,tau_uu,tau_vv,tau_ww,tau_uv,tau_uw,tau_vw,tau_uvm,tau_uwm,tau_vwm);	//3D-ADV
					}
					fclose(eingabe2);
				}
			}
		}
		}
	}
	fclose(ausgabe);
	fclose(eingabe1);
}
