/*****************************************************BOOTSTRAP**********************************************************/

/* Programm zur Berechnung der optimalen Messzeit der zwei mittleren Geschwindigkeitskomponenten u und w, der zwei Geschwindigkeitsfluktuationen und der Reynoldsschubspannung. Die Ausgabedatei DATUM.ot (o ptimal t ime) beinhaltet das Format: y z mitt_u_ot mitt_v_ot Stabw_u_ot Stabw_w_ot Reynoldssp_ot */

#include<stdio.h>
#include<string.h>
#include<math.h>
#include<stdlib.h>

#define PFAD_LAENGE 255
#define ZEILEN_LAENGE 250
#define MAX_LAENGE 10000



typedef struct feld{
	double boot[5];
} feld;


feld bootstrapping(FILE *datei, double u_mit, double w_mit, double u_rms, double w_rms, double reynolds,int y1,int y2,int y3,int pkt){
	
	int i=1,n=0,k,l,j,weiter,anzahl_bs=30,delta_rs,n_bs;
	double t,y,z,v,null=0,ans;
	
	double SE[MAX_LAENGE],m_SE[MAX_LAENGE],a_SE[MAX_LAENGE],max_SE,SumSqDiff;
	double SumSqDiff_Flkt,Sum;
	double u[MAX_LAENGE],u_mittel[anzahl_bs+1][MAX_LAENGE],step_u;
	double w[MAX_LAENGE],w_mittel[anzahl_bs+1][MAX_LAENGE],step_w;
	double u_Flkt,step_u_rms;
	double w_Flkt,step_w_rms;
	double ProdDiff,uw_Flkt,step_reynolds,rho_w=1000.0,cm2_m2=10000.0;
	
	char zeile[200], punkt[10],ausgabedatei[50],ausgabe_u[50],ausgabe_w[50],ausgabe_us[50],ausgabe_ws[50],ausgabe_rey[50];
	feld time;
	
	FILE *ausgabe;
	
	/* Anlegen der Datendateien fuer die graphische Darstellung von RS SE m_SE und a_SE jeden Punktes */
	
	sprintf(punkt,"%i%i%i_%i",y1,y2,y3,pkt);
	strcpy(ausgabedatei,"../../testweg/");
	strcat(ausgabedatei,punkt);
	
	/* Einlesen der Geschwindigkeiten aus .tp-Datei und Summenbildung */
	
	while(!feof(datei)){
		fgets(zeile,200,datei);
		weiter=feof(datei);
		if(weiter==0){
			sscanf(zeile,"%lf%lf%lf%lf%lf%lf",&t,&y,&z,&u[i],&v,&w[i]);
			i++;
			n++;
		}
	}
	
	/* Bestimmung der betrachteten Aufzeichnungszeit (RL) */
	
	delta_rs=n/anzahl_bs;
	
	/* Optimale Aufzeichnungszeit fuer u_mittel */
	
	strcpy(ausgabe_u,ausgabedatei);
	strcat(ausgabe_u,"SE_u.tmp");
	ausgabe=fopen(ausgabe_u,"w");
	
	max_SE=0;
	ans=-0.5;
	for(i=1;i<=anzahl_bs;i++){
		n_bs=i*delta_rs;
		SumSqDiff=0;
		l=0;
		for(j=1;j<=n-n_bs;j++){
			Sum=0;
			for(k=0;k<n_bs;k++){
				Sum+=u[j+k];
			}
			u_mittel[i][j]=Sum/n_bs;
			SumSqDiff+=(u_mittel[i][j]-u_mit)*(u_mittel[i][j]-u_mit);
			l++;
		}
		SE[i]=sqrt(SumSqDiff/l);
		if(i>1)
			m_SE[i]=SE[i]-SE[i-1];
		if(i>2)
			a_SE[i]=m_SE[i]-m_SE[i-1];
		if(i>2&&a_SE[i]>max_SE){
			max_SE=a_SE[i];
			ans=i*delta_rs;
		}
		if(i==1)
			fprintf(ausgabe,"%i\t%lf\t%lf\t%lf\n",i*delta_rs,SE[i],null,null);
		if(i==2)
			fprintf(ausgabe,"%i\t%lf\t%lf\t%lf\n",i*delta_rs,SE[i],m_SE[i],null);
		if(i>2)
			fprintf(ausgabe,"%i\t%lf\t%lf\t%lf\n",i*delta_rs,SE[i],m_SE[i],a_SE[i]);
	}
	fclose(ausgabe);
	step_u=ans;
	
	/* Optimale Aufzeichnungszeit fuer w_mittel */
	
	strcpy(ausgabe_w,ausgabedatei);
	strcat(ausgabe_w,"SE_w.tmp");
	ausgabe=fopen(ausgabe_w,"w");
	
	max_SE=0;
	ans=-0.5;
	for(i=1;i<=anzahl_bs;i++){
		n_bs=i*delta_rs;
		SumSqDiff=0;
		l=0;
		for(j=1;j<=n-n_bs;j++){
			Sum=0;
			for(k=0;k<n_bs;k++){
				Sum+=w[j+k];
			}
			w_mittel[i][j]=Sum/n_bs;
			SumSqDiff+=(w_mittel[i][j]-w_mit)*(w_mittel[i][j]-w_mit);
			l++;
		}
		SE[i]=sqrt(SumSqDiff/l);
		if(i>1)
			m_SE[i]=SE[i]-SE[i-1];
		if(i>2)
			a_SE[i]=m_SE[i]-m_SE[i-1];
		if(i>2&&a_SE[i]>max_SE){
			max_SE=a_SE[i];
			ans=i*delta_rs;
		}
		if(i==1)
			fprintf(ausgabe,"%i\t%lf\t%lf\t%lf\n",i*delta_rs,SE[i],null,null);
		if(i==2)
			fprintf(ausgabe,"%i\t%lf\t%lf\t%lf\n",i*delta_rs,SE[i],m_SE[i],null);
		if(i>2)
			fprintf(ausgabe,"%i\t%lf\t%lf\t%lf\n",i*delta_rs,SE[i],m_SE[i],a_SE[i]);
	}
	fclose(ausgabe);
	step_w=ans;
	
	/* Optimale Aufzeichnungszeit fuer u' */
	
	strcpy(ausgabe_us,ausgabedatei);
	strcat(ausgabe_us,"SE_us.tmp");
	ausgabe=fopen(ausgabe_us,"w");
	
	max_SE=0;
	ans=-0.5;
	for(i=1;i<=anzahl_bs;i++){
		n_bs=i*delta_rs;
		SumSqDiff=0;
		l=0;
		for(j=1;j<=n-n_bs;j++){
			SumSqDiff_Flkt=0;
			for(k=0;k<n_bs;k++){
				SumSqDiff_Flkt+=(u[j+k]-u_mittel[i][j])*(u[j+k]-u_mittel[i][j]);
			}
			u_Flkt=sqrt(SumSqDiff_Flkt/(n_bs-1));
			SumSqDiff+=(u_Flkt-u_rms)*(u_Flkt-u_rms);
			l++;
		}
		SE[i]=sqrt(SumSqDiff/l);
		if(i>1)
			m_SE[i]=SE[i]-SE[i-1];
		if(i>2)
			a_SE[i]=m_SE[i]-m_SE[i-1];
		if(i>2&&a_SE[i]>max_SE){
			max_SE=a_SE[i];
			ans=i*delta_rs;
		}
		if(i==1)
			fprintf(ausgabe,"%i\t%lf\t%lf\t%lf\n",i*delta_rs,SE[i],null,null);
		if(i==2)
			fprintf(ausgabe,"%i\t%lf\t%lf\t%lf\n",i*delta_rs,SE[i],m_SE[i],null);
		if(i>2)
			fprintf(ausgabe,"%i\t%lf\t%lf\t%lf\n",i*delta_rs,SE[i],m_SE[i],a_SE[i]);
	}
	fclose(ausgabe);
	step_u_rms=ans;
	
	/* Optimale Aufzeichnungszeit fuer w' */
	
	strcpy(ausgabe_ws,ausgabedatei);
	strcat(ausgabe_ws,"SE_ws.tmp");
	ausgabe=fopen(ausgabe_ws,"w");
	
	max_SE=0;
	ans=-0.5;
	for(i=1;i<=anzahl_bs;i++){
		n_bs=i*delta_rs;
		SumSqDiff=0;
		l=0;
		for(j=1;j<=n-n_bs;j++){
			SumSqDiff_Flkt=0;
			for(k=0;k<n_bs;k++){
				SumSqDiff_Flkt+=(w[j+k]-w_mittel[i][j])*(w[j+k]-w_mittel[i][j]);
			}
			w_Flkt=sqrt(SumSqDiff_Flkt/(n_bs-1));
			SumSqDiff+=(w_Flkt-w_rms)*(w_Flkt-w_rms);
			l++;
		}
		SE[i]=sqrt(SumSqDiff/l);
		if(i>1)
			m_SE[i]=SE[i]-SE[i-1];
		if(i>2)
			a_SE[i]=m_SE[i]-m_SE[i-1];
		if(i>2&&a_SE[i]>max_SE){
			max_SE=a_SE[i];
			ans=i*delta_rs;
		}
		if(i==1)
			fprintf(ausgabe,"%i\t%lf\t%lf\t%lf\n",i*delta_rs,SE[i],null,null);
		if(i==2)
			fprintf(ausgabe,"%i\t%lf\t%lf\t%lf\n",i*delta_rs,SE[i],m_SE[i],null);
		if(i>2)
			fprintf(ausgabe,"%i\t%lf\t%lf\t%lf\n",i*delta_rs,SE[i],m_SE[i],a_SE[i]);
	}
	fclose(ausgabe);
	step_w_rms=ans;
	
	/* Optimale Aufzeichnungszeit fuer u'w' */
	
	strcpy(ausgabe_rey,ausgabedatei);
	strcat(ausgabe_rey,"SE_rey.tmp");
	ausgabe=fopen(ausgabe_rey,"w");
	
	max_SE=0;
	ans=-0.5;
	for(i=1;i<=anzahl_bs;i++){
		n_bs=i*delta_rs;
		SumSqDiff=0;
		l=0;
		for(j=1;j<=n-n_bs;j++){
			ProdDiff=0;
			for(k=0;k<n_bs;k++){
				ProdDiff+=(u[j+k]-u_mittel[i][j])*(w[j+k]-w_mittel[i][j]);
			}
			uw_Flkt=ProdDiff/n_bs;
			SumSqDiff+=(uw_Flkt*rho_w/cm2_m2-reynolds)*(uw_Flkt*rho_w/cm2_m2-reynolds);
			l++;
		}
		SE[i]=sqrt(SumSqDiff/l);
		if(i>1)
			m_SE[i]=SE[i]-SE[i-1];
		if(i>2)
			a_SE[i]=m_SE[i]-m_SE[i-1];
		if(i>2&&a_SE[i]>max_SE){
			max_SE=a_SE[i];
			ans=i*delta_rs;
		}
		if(i==1)
			fprintf(ausgabe,"%i\t%lf\t%lf\t%lf\n",i*delta_rs,SE[i],null,null);
		if(i==2)
			fprintf(ausgabe,"%i\t%lf\t%lf\t%lf\n",i*delta_rs,SE[i],m_SE[i],null);
		if(i>2)
			fprintf(ausgabe,"%i\t%lf\t%lf\t%lf\n",i*delta_rs,SE[i],m_SE[i],a_SE[i]);
	}
	fclose(ausgabe);
	step_reynolds=ans;
	
	time.boot[0]=step_u*0.04+0.02;
	time.boot[1]=step_w*0.04+0.02;
	time.boot[2]=step_u_rms*0.04+0.02;
	time.boot[3]=step_w_rms*0.04+0.02;
	time.boot[4]=step_reynolds*0.04+0.02;
	
	return time;
}


main(){
	
	printf("\n\tB o o t s t r a p p i n g\n\tProgramm zur Berechnung optimalen Messzeit fuer u-v-Mittelwerte,\n\tderen Standardabweichungen und der Reynoldsschubspannung\n\tan Messpunkten einer Profilaufnahme\n\tAutor: Christian Noss\n\tErstellt am 26.10.2005\n\tAusgabedatei: */ddmmyy.ot\n\tAusgabeformat: y z mitt_u_ot mitt_v_ot Stabw_u_ot Stabw_w_ot Reynoldssp._ot\n\n");
	
	FILE *eingabe1, *eingabe2, *eingabe3, *ausgabe;
	char pfad[PFAD_LAENGE], zielpfad[PFAD_LAENGE], y_pfad[PFAD_LAENGE],zy_pfad[PFAD_LAENGE];
	char lamellenordner[5], lamellenpkt[5], datum[15];
	char tp_datei[PFAD_LAENGE], ot_datei[PFAD_LAENGE], kot_datei[PFAD_LAENGE], std_datei[PFAD_LAENGE];
	char tp_zeile[ZEILEN_LAENGE], kot_zeile[ZEILEN_LAENGE], std_zeile[ZEILEN_LAENGE];
	double t, y, z, u_mittel, v_mittel, w_mittel,ot_u,ot_w,ot_su,ot_sw,ot_rey;
	double stdm_u, stdm_v, stdm_w, reym, rho_w=1000;
	int i,j,k,l,n=9,m=25;
	feld ergebnis;
	
	printf("Dateipfad des ADV-Messordners:\n");						/* Einlesen des Ordners */
	gets(pfad);
	strcat(pfad,"/");
	printf("Eingabe des Messdatums (ddmmyy) ohne oder mit Zusatz (_Stationsbez.):\n");	/* Einlesen des Messtages */
	gets(datum);
	strcat(pfad,datum);
	strcpy(kot_datei,pfad);
	strcat(kot_datei,"/Punktmittel.kot");
	
	eingabe1=fopen(kot_datei,"r");
	
	printf("Dateipfad des Stdabw.+Reynolds.-Ordners:\n");					/* Einlesen des Ordners */
	gets(std_datei);
	strcat(std_datei,"/");
	strcat(std_datei,datum);
	strcat(std_datei,"_std.rey");
	
	eingabe2=fopen(std_datei,"r");
	
	printf("Zielpfad der Ausgabedatei (bis Datum):\n");			/* Einlesen des Zielpfades */
	gets(zielpfad);
	strcat(zielpfad,"/");
	strcat(zielpfad,datum);
	strcpy(ot_datei,zielpfad);
	strcat(ot_datei,".ot");
	
	ausgabe=fopen(ot_datei,"w");
	
	for(i=0;i<=m;i++){						/* Schleife fuer 1. Lamellenwert */
	
		for(j=0;j<=n;j++){					/* Schleife fuer 2. Lamellenwert */
		for(k=0;k<=n;k++){					/* Schleife fuer 3. Lamellenwert (Zweite Nachkommastelle) */
		
			strcpy(y_pfad,pfad);				/* Kopieren und Ueberschreiben des y-zielpfad mit zielpfad */
			sprintf(lamellenordner,"/%i_%i%i",i,j,k);
			strcat(y_pfad,lamellenordner);			/* Lamellenordner an Pfad anhaengen */
			
			
			for(l=1;l<=m;l++){				/* Schleife fuer Lamellenpunkt */ 
			
				strcpy(zy_pfad,y_pfad);			/* Kopieren bzw. Ueberschreiben des zypfad1 mit ypfad1 */
				sprintf(lamellenpkt,"/%i",l);
				strcat(zy_pfad,lamellenpkt);		/* Messpunkt an Pfad anhaengen */
				strcpy(tp_datei,zy_pfad);
				strcat(tp_datei,".tp");
			
				eingabe3=fopen(tp_datei,"r");		/* Oeffnen der tp.-Datei */
				
				if(eingabe3!=NULL){
				
					fgets(kot_zeile,250,eingabe1);
					sscanf(kot_zeile,"%lf%lf%lf%lf%lf",&y,&z,&u_mittel,&v_mittel,&w_mittel);
					
					fgets(std_zeile,250,eingabe2);
					sscanf(std_zeile,"%lf%lf%lf%lf%lf%lf",&y,&z,&stdm_u,&stdm_v,&stdm_w,&reym);
					
					ergebnis=bootstrapping(eingabe3,u_mittel,w_mittel,stdm_u,stdm_w,reym,i,j,k,l);
					
					ot_u=ergebnis.boot[0];
					ot_w=ergebnis.boot[1];
					ot_su=ergebnis.boot[2];
					ot_sw=ergebnis.boot[3];
					ot_rey=ergebnis.boot[4];
					
					fprintf(ausgabe,"%lf\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\n",y,z,ot_u,ot_w,ot_su,ot_sw,ot_rey);
					
					fclose(eingabe3);
				}
			}
		}
		}
	}
	fclose(ausgabe);
	fclose(eingabe1);
	fclose(eingabe2);
	printf("Fertig\n");
}
