/************************************HYDRODGM*******************************************/
/* 	Programm zur Ermittlung des hydraulischen Radius, der mittleren Fließgeschwindigkeit
	und der Beiwerte kst und lambda eines Gewaesserabschnittes.
	Eingabedateien: n-*.dat Profilschnittdateien. 
	printf-Ausgabe beinhaltet: Q <um> <rhy> IE kst lambda 				*/


#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

/*	Hauptprogramm	*/

main(){
	FILE *eingabe;
	int i,j,k,l,m,n;
	double	y[256],z[256],z_wsp,Q,Ie,yl,yr,y_test,z_test,gk;
	double	a,u,A[120],U[120],AS,um,lambda,kst,S_um;
	double	Sum_rhy,rhy[120],rhyS,rhy_Ges,um_Ges;
	char zeile[128],daten[8],pfad[256],eingabepfad[256];
	
//Abfragen
	printf("Ordnerpfad der Schnittdaten (*.dat):\n");	//Dateien mit den Schnitten aus einem DGM
	scanf("%s",&pfad);
	printf("Wieviele Schnitte sind vorhanden:\n");
	scanf("%d",&n);
	printf("Wasserspiegellagenniveau [m HN]:\n");
	scanf("%lf",&z_wsp);
	printf("Durchluss [m³/s]:\n");
	scanf("%lf",&Q);
	printf("Energieliniengefälle [1/1]:\n");
	scanf("%lf",&Ie);
	
	strcat(pfad,"/");
	
	Sum_rhy=0.0,S_um=0.0;
	for(i=1;i<=n;i++){				//Schleife der Schnittdateien und deren rhy bei geg. Wsp
		strcpy(eingabepfad,pfad);			
		sprintf(daten,"%i.dat",i);			//Oeffnen einer Schnittdatei
		strcat(eingabepfad,daten);
		eingabe=fopen(eingabepfad,"r");
		fgets(zeile,127,eingabe);
		sscanf(zeile,"%lf%lf%lf%lf%lf",&gk,&gk,&z[0],&y[0],&gk);	
		m=1;
		while(!feof(eingabe)){					//Einlesen der Schnittdaten
			fgets(zeile,127,eingabe);
			sscanf(zeile,"%lf%lf%lf%lf%lf",&gk,&gk,&z_test,&y_test,&gk);
			while(z_test==z[0]){						//Verwerfen der Punkte auf Interpolationsnetz
				fgets(zeile,127,eingabe);
				if(feof(eingabe)) break;
				sscanf(zeile,"%lf%lf%lf%lf%lf",&gk,&gk,&z_test,&y_test,&gk);
			}
			if(feof(eingabe)) break;
			else{			//Uebernehmen der Punkte des Profilschnittes
				z[m]=z_test;
				y[m]=y_test;
			}
			m++;
		}
		k=0;l=0;AS=0.0;um=0.0;
		for(j=2;j<m;j++){				//Berechnen der Teilflaechen/-umfaenge in einem Schnitt
			if(z[j-1]>z_wsp&&z[j]<z_wsp){		//Dreieck des linken Uferpunktes
				yl=y[j-1]+(y[j]-y[j-1])/(z[j]-z[j-1])*(z_wsp-z[j-1]);
				a=(y[j]-yl)/2*(z_wsp-z[j]);
				u=sqrt((y[j]-yl)*(y[j]-yl)+(z_wsp-z[j])*(z_wsp-z[j]));
				A[k]=a;
				U[k]=u;
			}
			if(z[j-1]<z_wsp&&z[j]<z_wsp){	//Trapez, wenn beide Punkte unter Wasser
				a=(y[j]-y[j-1])*(z_wsp-(z[j]+z[j-1])/2);
				u=sqrt((y[j]-y[j-1])*(y[j]-y[j-1])+(z[j-1]-z[j])*(z[j-1]-z[j]));
				A[k]+=a;
				U[k]+=u;
			}
			if(z[j-1]<z_wsp&&z[j]>z_wsp){	//Dreieck des rechten Uferpunktes 
				yr=y[j-1]+(y[j]-y[j-1])/(z[j]-z[j-1])*(z_wsp-z[j-1]);
				a=(yr-y[j-1])/2*(z_wsp-z[j-1]);
				u=sqrt((yr-y[j-1])*(yr-y[j-1])+(z_wsp-z[j-1])*(z_wsp-z[j-1]));
				A[k]+=a;
				U[k]+=u;
				rhy[k]=A[k]/U[k];
				AS+=A[k];
				k++;
				l++;
			}	
		}
		rhyS=0.0;
		for(k=0;k<l;k++) rhyS+=rhy[k]*(A[k]/AS);	//Hydraulischer Radius des Schnittes (gewichtetes Mittel)
		Sum_rhy+=rhyS;
		fclose(eingabe);
		um=Q/AS;
		S_um+=um;
	}
	rhy_Ges=Sum_rhy/n;					//Berechnung Hydraulischer Radius
	um_Ges=S_um/n;						//Mittlere Fliessgeschwindigkeit
	lambda=8/(um_Ges*um_Ges)*9.81*rhy_Ges*Ie;		//Widerstandsbeiwert
	kst=um_Ges/(sqrt(Ie)*pow(rhy_Ges,0.6667));		//Geschwindigkeitsbeiwert
	printf("\nQ=%lf\t<um>=%lf\t<rhy>=%lf\tIe=%lf\tkst=%lf\tlambda=%lf\n\n",Q,um_Ges,rhy_Ges,Ie,kst,lambda);
}
